package com.gic.haoban.manage.service.service.impl;

import java.util.Collection;
import java.util.Date;
import java.util.List;
import java.util.Set;

import org.springframework.beans.factory.annotation.Autowired;

import com.alibaba.dubbo.config.annotation.Service;
import com.gic.haoban.common.utils.EntityUtil;
import com.gic.haoban.common.utils.StringUtil;
import com.gic.haoban.manage.api.dto.ExternalClerkRelatedDTO;
import com.gic.haoban.manage.api.dto.MemberUnionidRelatedDTO;
import com.gic.haoban.manage.service.dao.mapper.TabHaobanExternalClerkRelatedMapper;
import com.gic.haoban.manage.service.entity.TabHaobanExternalClerkRelated;
import com.gic.haoban.manage.service.service.ExternalClerkRelatedService;

@Service
public class ExternalClerkRelatedServiceImpl implements ExternalClerkRelatedService {
	
	@Autowired
	private TabHaobanExternalClerkRelatedMapper mapper;

	@Override
	public void insert(TabHaobanExternalClerkRelated related) {
		String clerkId = related.getClerkId();
		String externalUserId = related.getExternalUserId();
		TabHaobanExternalClerkRelated tab = mapper.selectByClerkIdAndExternalUserId(clerkId,externalUserId);
		if(tab == null){
			String uuId = StringUtil.randomUUID();
			related.setStatusFlag(related.getStatusFlag() != null ? related.getStatusFlag() : 1);
			related.setExternalClerkRelatedId(uuId);
			related.setCreateTime(new Date());
			related.setUpdateTime(new Date());
			mapper.insertSelective(related);
		}
		
		
	}

	@Override
	public void delByUserIdAndExternalUserId(MemberUnionidRelatedDTO dto) {
		mapper.delByUserIdAndExternalUserId(EntityUtil.changeEntityByJSON(TabHaobanExternalClerkRelated.class, dto));
		
	}

	@Override
	public void delByUserIdAndExternalUserIdBatch(String wxEnterpriseId, String wxUserId, List<String> externalUserids) {
        mapper.delByUserIdAndExternalUserIdBatch(wxUserId, wxEnterpriseId, externalUserids);
    }

	@Override
	public void delByClerkIdAndStaffId(String clerkId, String staffId) {
		mapper.delByClerkIdAndStaffId(clerkId,staffId);
	}

	@Override
	public void delByStoreIdAndStaffId(String storeId, String staffId) {
		mapper.delByStoreIdAndStaffId(storeId, staffId);
	}

	@Override
	public void delByStoreIds(Collection<String> storeIds) {
		mapper.delByStoreIds(storeIds);
	}

	@Override
	public void cleanStaffRelated(String wxEnterpriseId, List<String> staffIds) {
		if(staffIds != null && !staffIds.isEmpty()){
			mapper.cleanStaffRelated(wxEnterpriseId,staffIds);
		}

	}

	@Override
	public void update(TabHaobanExternalClerkRelated exsitDTO) {
		exsitDTO.setUpdateTime(new Date());
		mapper.updateByPrimaryKeySelective(exsitDTO);
		
	}

	@Override
	public TabHaobanExternalClerkRelated getByParams(String userId, String wxEnterpriseId, String name,
			String createTime) {
		return mapper.getByParams(userId, wxEnterpriseId,name,createTime);
	}

	@Override
	public List<TabHaobanExternalClerkRelated> listByExTernalUseridAndWxUserId(String externalUserid, String wxUserId) {
		return mapper.listByExTernalUseridAndWxUserId(externalUserid,wxUserId);
	}

	@Override
	public List<TabHaobanExternalClerkRelated> listByExTernalUseridAndWxUserIdAllStatus(String externalUserid, String wxUserId) {
		return mapper.listByExTernalUseridAndWxUserIdAllStatus(externalUserid, wxUserId);
	}

	@Override
	public ExternalClerkRelatedDTO getByMemberId(String wxUserId, String memberId) {
		return EntityUtil.changeEntityByJSON(ExternalClerkRelatedDTO.class, mapper.getByMemberId(wxUserId,memberId));
	}

	@Override
	public List<TabHaobanExternalClerkRelated> listExternalByUnionId(String enterpriseId, String unionId) {
		return mapper.listExternalByUnionId(enterpriseId, unionId);
	}

	@Override
	public List<TabHaobanExternalClerkRelated> listExternalByExternalUserid(String wxEnterpriseId, String externalUserid) {
		return mapper.listByExternalUserId(wxEnterpriseId, externalUserid);
	}
}
