package com.gic.haoban.manage.service.service.out.impl;


import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.crypto.SecureUtil;
import cn.hutool.crypto.digest.MD5;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.gic.api.base.commons.JSONResponse;
import com.gic.api.base.commons.Page;
import com.gic.clerk.api.dto.ClerkDTO;
import com.gic.clerk.api.service.ClerkService;
import com.gic.clerk.api.service.PowerService;
import com.gic.commons.util.DateUtil;
import com.gic.commons.util.EntityUtil;
import com.gic.commons.util.GICMQClientUtil;
import com.gic.enterprise.api.dto.StoreDTO;
import com.gic.enterprise.api.service.EnterpriseService;
import com.gic.enterprise.api.service.StoreService;
import com.gic.haoban.app.customer.dto.ChildDTO;
import com.gic.haoban.app.customer.dto.CustomerDTO;
import com.gic.haoban.app.customer.dto.FilterListDTO;
import com.gic.haoban.app.customer.dto.MemberInfoListParamsDTO;
import com.gic.haoban.app.customer.enums.GicQywxSyncTypeEnum;
import com.gic.haoban.app.customer.enums.QywxSyncTaskTypeEnum;
import com.gic.haoban.app.customer.service.api.service.CustomerApiService;
import com.gic.haoban.base.api.common.BasePageInfo;
import com.gic.haoban.base.api.common.ServiceResponse;
import com.gic.haoban.common.utils.PageUtil;
import com.gic.haoban.manage.api.dto.*;
import com.gic.haoban.manage.api.enums.SecretTypeEnum;
import com.gic.haoban.manage.api.service.*;
import com.gic.haoban.manage.service.config.Config;
import com.gic.haoban.manage.service.dao.mapper.MemberUnionidRelatedMapper;
import com.gic.haoban.manage.service.dao.mapper.TabHaobanWelcomeMapper;
import com.gic.haoban.manage.service.entity.*;
import com.gic.haoban.manage.service.exception.WxApiLimitException;
import com.gic.haoban.manage.service.pojo.DealQywxExternalUserPojo;
import com.gic.haoban.manage.service.pojo.ExternalUserPojo;
import com.gic.haoban.manage.service.pojo.QywxTagSyncInfoPojo;
import com.gic.haoban.manage.service.service.*;
import com.gic.haoban.manage.service.util.EmojiFilterUtil;
import com.gic.member.api.dto.MemberDTO;
import com.gic.member.api.service.MemberOpenCardBusinessService;
import com.gic.member.api.service.MemberService;
import com.gic.mq.sdk.GicMQClient;
import com.gic.redis.data.util.RedisUtil;
import com.gic.search.engine.api.constant.MemberDataEnum;
import com.gic.search.engine.api.constant.OperateEnum;
import com.gic.search.engine.api.dto.ESResponseQueryBatch;
import com.gic.search.engine.api.dto.dynamic.DynamicSearchDTO;
import com.gic.search.engine.api.filter.NewNodeAddUtil;
import com.gic.search.engine.api.service.dynamic.ESDataDynamicOperationApiService;
import com.gic.wechat.api.dto.qywx.*;
import com.gic.wechat.api.service.qywx.QywxSuiteApiService;
import com.gic.wechat.api.service.qywx.QywxUserApiService;
import com.github.pagehelper.PageHelper;
import com.google.common.collect.Sets;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.stream.Collectors;

@Service
public class MemberUnionidRelatedApiServiceImpl implements MemberUnionidRelatedApiService {
    private static final Logger log = LogManager.getLogger(MemberUnionidRelatedApiServiceImpl.class);
    @Autowired
    private MemberUnionRelatedService memberUnionRelatedService;
    @Autowired
    private StaffService staffService;
    @Autowired
    private QywxUserApiService qywxUserApiService;
    @Autowired
    private com.gic.enterprise.api.service.StoreGroupService gicDepartmentService;
    @Autowired
    private MemberService memberService;
    @Autowired
    private WxEnterpriseRelatedService wxEnterpriseRelatedService;
    @Autowired
    private WxEnterpriseService wxEnterpriseService;

    private static final String SELF_APP = "selfSuiteId";

    @Autowired
    private MemberOpenCardBusinessService memberOpenCardBusinessService;

    @Autowired
    private ClerkService clerkService;
    @Autowired
    private DepartmentApiService departmentApiService;

    @Autowired
    private MemberUnionidRelatedMapper memberUnionidRelatedMapper;

    @Autowired
    private StaffDepartmentRelatedService staffDepartmentRelatedService;
    @Autowired
    private ESDataDynamicOperationApiService eSDataDynamicOperationApiService;
    @Autowired
    private ClerkMainStoreRelatedService clerkMainStoreRelatedService;
    @Autowired
    private StoreService storeService;
    @Autowired
    private Config config;
    @Autowired
    private QywxSuiteApiService qywxSuiteApiService;
    @Autowired
    private MaterialApiService materialApiService;

    @Autowired
    private SecretSettingService secretSettingService;

    @Autowired
    private StaffClerkRelationService staffClerkRelationService;
    @Autowired
    private ExternalClerkRelatedService externalClerkRelatedService;
    @Autowired
    private PowerService powerService;

    @Autowired
    private EnterpriseService enterpriseService;

    @Autowired
    private MiniprogramSettingService miniprogramSettingService;

    @Autowired
    private TabHaobanWelcomeMapper welcomeMapper;

    @Autowired
    private CheckQywxSettingApiService checkQywxSettingApiService;

    @Autowired
    private CustomerApiService customerApiService;

    @Autowired
    private QywxTagApiService qywxTagApiService;

    @Override
    public void dealQywxExternalUser(String params) {
        log.info("回调：{}", params);
        DealQywxExternalUserPojo externalUserPojo = JSONObject.parseObject(params, DealQywxExternalUserPojo.class);
        if (externalUserPojo.getType() == DealQywxExternalUserPojo.DealType.del.getType()) {
            this.delMemberUnionidRelatedProcess(externalUserPojo.getData());
        } else if (externalUserPojo.getType() == DealQywxExternalUserPojo.DealType.add.getType()) {
            this.addMemberUnionidRelatedNew(externalUserPojo.getData());
        } else if (externalUserPojo.getType() == DealQywxExternalUserPojo.DealType.edit.getType()) {
            this.editMemberUnionidRelatedProcess(externalUserPojo.getData());
        }

    }

    @Override
    public List<MemberStoreDTO> listByExTernalUseridAndWxUserId(String externalUserid, String wxUserId, String storeId) {
        List<TabHaobanExternalClerkRelated> list = externalClerkRelatedService.listByExTernalUseridAndWxUserId(externalUserid, wxUserId);
        List<MemberStoreDTO> result = new ArrayList<>();
        if (CollectionUtil.isEmpty(list)) {
            return null;
        }
        String wxEnterpriseId = list.get(0).getWxEnterpriseId();
        TabHaobanStaff haobanStaff = staffService.selectByUserIdAndEnterpriseId(wxUserId, wxEnterpriseId);
        if (null == haobanStaff) {
            log.info("staff不存在");
            return null;
        }
        List<StaffClerkRelationDTO> clerkRelationDTOS = staffClerkRelationService.listBindCodeByStaffId(null, haobanStaff.getStaffId());
        if (CollectionUtil.isEmpty(clerkRelationDTOS)) {
            log.info("staff关联门店不存在1");
            return null;
        }
        List<String> storeIds = clerkRelationDTOS.stream().filter(s -> (s.getStoreId() != null || "".equals(s.getStoreId()))).map(s -> s.getStoreId()).collect(Collectors.toList());
        if (CollectionUtil.isEmpty(storeIds)) {
            log.info("staff关联门店不存在2");
            return null;
        }
        //2、获取member的storeId
        for (TabHaobanExternalClerkRelated tab : list) {
            if (StringUtils.isNotBlank(storeId) && (!storeId.equals(tab.getStoreId()))) {
                continue;
            }
            String memberId = tab.getMemberId();
            if (StringUtils.isEmpty(memberId)) {
                continue;
            }
//            String gicEnterpriseId = tab.getEnterpriseId();
//            JSONObject searchJson = new JSONObject();
//            searchJson = NewNodeAddUtil.addNewNodeForAnd(MemberDataEnum.member_memberId.getCode(), OperateEnum.OPERATE_EQ.getValue(), memberId, searchJson);
//            DynamicSearchDTO dynamicSearchDTO = new DynamicSearchDTO();
//            dynamicSearchDTO.setEnterpriseId(gicEnterpriseId);
//            dynamicSearchDTO.setColumnCategoryCode("member");
//            dynamicSearchDTO.setSearchJson(searchJson);
//            dynamicSearchDTO.setBegin(0);
//            dynamicSearchDTO.setRecordNumber(1);
//            log.info("gicEnterpriseId=========>{},searchJson=========={}", gicEnterpriseId, searchJson);
//            ESResponseQueryBatch responseQuery = eSDataDynamicOperationApiService.queryDataBatch(dynamicSearchDTO, false, null);
//            if (null == responseQuery) {
//                log.info("会员不存在1");
//                continue;
//            }
//            List<JSONObject> res = responseQuery.getRes();
//            if (CollectionUtil.isEmpty(res)) {
//                log.info("会员不存在2");
//                continue;
//            }
//            String storeId = "";
//            for (JSONObject jsonObject : res) {
//                storeId = jsonObject.get("storeId") == null ? "" : jsonObject.get("storeId").toString();
//            }
//            if (StringUtils.isEmpty(storeId)) {
//                log.info("会员门店不存在");
//                continue;
//            }
//            String[] memberStoreIds = storeId.split(" ");
//            List<String> memberStoreIdList = Arrays.asList(memberStoreIds);
//            if (CollectionUtil.isEmpty(memberStoreIdList)) {
//                log.info("会员门店不存在");
//                continue;
//            }
//            log.info("memberStoreIdList===============>{}", JSONObject.toJSONString(memberStoreIdList));
//            log.info("storeIds===============>{}", JSONObject.toJSONString(storeIds));
//            //取交集(解决不支持的报错现象)
//            List list3 = new ArrayList(memberStoreIdList);
//            List list4 = new ArrayList(storeIds);
//            list3.retainAll(list4);
//            if (CollectionUtil.isEmpty(list3)) {
//                continue;
//            } else {
//                for (Object resultStoreId : list3) {
//                    MemberStoreDTO dto = new MemberStoreDTO();
//                    dto.setMemberId(memberId);
//                    dto.setStoreId(resultStoreId.toString());
//                    result.add(dto);
//                }
//
//            }
            CustomerDTO params = new CustomerDTO();
            params.setClerkType("0");
            params.setStoreId(tab.getStoreId());
            params.setClerkId(tab.getClerkId());
            params.setEnterpriseId(tab.getEnterpriseId());
            params.setStoreManagerFlag(isManager(tab.getClerkId()));


            MemberInfoListParamsDTO memberInfoListParamsDTO = new MemberInfoListParamsDTO();
            memberInfoListParamsDTO.setMemberId(tab.getMemberId());

            FilterListDTO filterListDTO = new FilterListDTO();
            filterListDTO.setFilterType("4");
            ChildDTO childDTO = new ChildDTO();
            childDTO.setId("");
            filterListDTO.setChild(childDTO);
            List<FilterListDTO> filterList = new ArrayList<>();
            filterList.add(filterListDTO);

            memberInfoListParamsDTO.setFilterList(filterList);


            boolean flag = customerApiService.checkMemberRangeByMemberId(params, memberInfoListParamsDTO);
            if (flag) {
                MemberStoreDTO dto = new MemberStoreDTO();
                dto.setMemberId(tab.getMemberId());
                dto.setStoreId(tab.getStoreId());
                result.add(dto);
            }
        }
        return result;
    }

    private boolean isManager(String clerkId) {
        ClerkDTO clerkDTO = clerkService.getclerkById(clerkId);
        if (clerkDTO != null) {
            Integer isManager = clerkDTO.getClerkType();
            if (isManager != null && isManager == 1 && clerkDTO.getStatus() == 1) {
                return true;
            }
        }
        return false;
    }

    /**
     * 根据导购导购微信id和会员id查询关联关系
     *
     * @return : 返回关联关系
     */
    @Override
    public ExternalClerkRelatedDTO getByWxUserIdMemberId(String wxUserId, String memberId) {
        return externalClerkRelatedService.getByMemberId(wxUserId, memberId);
    }

    @Override
    public MemberUnionidRelatedDTO getByUnionId(String staffId, String unionid) {
        TabHaobanStaff staff = staffService.selectById(staffId);
        if (staff == null) {
            return null;
        }
        log.info("【查询会员】wxUserId={},unionid={}", staff.getWxUserId(), unionid);
        return memberUnionRelatedService.getByUnionId(staff.getWxEnterpriseId(), staff.getWxUserId(), unionid);
    }

    @Override
    public String addMemberUnionidRelated(MemberUnionidRelatedDTO dto) {
        DealQywxExternalUserPojo dealQywxExternalUserPojo = new DealQywxExternalUserPojo();
        dealQywxExternalUserPojo.setType(DealQywxExternalUserPojo.DealType.add.getType());
        dealQywxExternalUserPojo.setData(dto);

        GicMQClient instance = GICMQClientUtil.getClientInstance();
        try {
            instance.sendMessage("dealQywxExternalUserMq", JSONObject.toJSONString(dealQywxExternalUserPojo));
        } catch (Exception e) {
            log.info("异步处理异常：{}", e);
        }
        return null;
    }


    @Override
    public String addMemberUnionidRelatedNew(MemberUnionidRelatedDTO dto) {
        //解析组装信息
        dto = getMemberUnionidRelatedDTONew(dto);
        if (null == dto) {
            log.info("没处理完成-等下一次处理");
            return null;
        }
        insertExternalClerkRelatedNew(dto);
        return dto.getMemberUnionidRelatedId();
    }

    @Deprecated
    private void insertExternalClerkRelated(MemberUnionidRelatedDTO dto) {
        log.info("新增外部联系人开始：{}", JSONObject.toJSONString(dto));
        String wxUserId = dto.getWxUserId();
        String wxEnterpriseId = dto.getWxEnterpriseId();
        String name = dto.getExternalName();
        String createTime = dto.getAddCreateTime();
        String externalUserId = dto.getExternalUserid();
        String avatar = dto.getAvatar();
        String unionId = dto.getUnionid();
        if (StringUtils.isAnyBlank(wxUserId, wxEnterpriseId, name, createTime, unionId)) {
            log.info("【新增外部联系人】wxUserId={},wxEnterpriseId={},name={},createTime={},avatar={},unionId={}", wxUserId, wxEnterpriseId, name, createTime, avatar, unionId);
            return;
        }
        TabHaobanStaff staff = staffService.selectByUserIdAndEnterpriseId(wxUserId, wxEnterpriseId);
        if (staff == null) {
            return;
        }
        String staffId = staff.getStaffId();

        MemberDTO member = null;
        TabHaobanClerkMainStoreRelated r = clerkMainStoreRelatedService.getMainStoreByStaffId(staffId, wxEnterpriseId);
        if (r == null) {
            log.info("【新增外部联系人】主门店为空");
            return;
        }
        String storeId = r.getStoreId();

        StaffClerkRelationDTO staffClerkRelationDTO = staffClerkRelationService.getOneBindByStoreId(staffId, storeId);
        if (staffClerkRelationDTO == null) {
            log.info("【新增外币联系人】导购和clerk关联为空");
            return;
        }
        //新增导购和外部联系人关系
        String clerkCode = staffClerkRelationDTO.getClerkCode();
        ClerkDTO clerk = clerkService.getClerkByClerkCode(staffClerkRelationDTO.getEnterpriseId(), clerkCode);
        log.info("【新增外部联系人】clerkCode={},unionid:{}", clerkCode, unionId);
        if (clerk == null) {
            log.info("【新增外币联系人】导购为空");
            return;
        }
        String qrcodeParam = clerk.getQrcodeParam();
        if (StringUtils.isBlank(qrcodeParam)) {
            powerService.saveClerkQrCode(clerk.getClerkId());
            clerk = clerkService.getClerkByClerkCode(staffClerkRelationDTO.getEnterpriseId(), clerkCode);
            qrcodeParam = clerk.getQrcodeParam();
        }
        if (clerk != null && StringUtils.isNotBlank(qrcodeParam) && StringUtils.isNotBlank(unionId)) {
            log.info("【新增外部联系人会员】enterpriseId={},unionId={},name={},avatar={},QrcodeParam={}", staffClerkRelationDTO.getEnterpriseId(), unionId, name, avatar, qrcodeParam);
            member = memberOpenCardBusinessService.getMemberByQywxChannelParam(staffClerkRelationDTO.getEnterpriseId(), unionId, "", name, avatar, qrcodeParam);
        }

        TabHaobanExternalClerkRelated exsitDTO = externalClerkRelatedService.getByParams(wxUserId, wxEnterpriseId, name, createTime);
        String key = wxUserId + wxEnterpriseId + name + createTime;
        if (exsitDTO == null) {
            RedisUtil.lock(key, 1L);
            exsitDTO = externalClerkRelatedService.getByParams(wxUserId, wxEnterpriseId, name, createTime);
            RedisUtil.unlock(key);
        }
        if (exsitDTO == null) {
            TabHaobanExternalClerkRelated related = new TabHaobanExternalClerkRelated();
            related.setAddCreateTime(createTime);
            related.setClerkId(staffClerkRelationDTO.getClerkId());
            related.setEnterpriseId(staffClerkRelationDTO.getEnterpriseId());
            related.setExternalName(name);
            related.setExternalUserId(externalUserId);
            related.setStaffId(staffId);
            related.setMemberUnionidRelatedId(dto.getMemberUnionidRelatedId());
            related.setStoreId(r.getStoreId());
            related.setUnionid(unionId);
            related.setWxEnterpriseId(wxEnterpriseId);
            related.setWxUserId(wxUserId);
            if (member != null) {
                related.setMemberId(member.getMemberId());
            }
            externalClerkRelatedService.insert(related);

        } else {
            if (member != null) {
                exsitDTO.setMemberId(member.getMemberId());
            }
            exsitDTO.setMemberUnionidRelatedId(dto.getMemberUnionidRelatedId());
            exsitDTO.setExternalUserId(externalUserId);
            exsitDTO.setUnionid(unionId);
            exsitDTO.setStoreId(storeId);
            exsitDTO.setEnterpriseId(staffClerkRelationDTO.getEnterpriseId());
            exsitDTO.setClerkId(staffClerkRelationDTO.getClerkId());
            externalClerkRelatedService.update(exsitDTO);
        }

    }

    /**
     * 创建关联关系
     *
     * @param dto
     */
    private void insertExternalClerkRelatedNew(MemberUnionidRelatedDTO dto) {
        String wxUserId = dto.getWxUserId();
        String wxEnterpriseId = dto.getWxEnterpriseId();
        String name = dto.getExternalName();
        String createTime = dto.getAddCreateTime();
        String externalUserId = dto.getExternalUserid();
        String avatar = dto.getAvatar();
        String unionId = dto.getUnionid();
        if (StringUtils.isAnyBlank(wxUserId, wxEnterpriseId, name, createTime, externalUserId)) {
            log.info("【新增外部联系人】wxUserId={},wxEnterpriseId={},name={},createTime={},avatar={},unionId={},externalUserId={}", wxUserId, wxEnterpriseId, name, createTime, avatar, unionId, externalUserId);
            checkQywxSettingApiService.saveFriendCallback(wxEnterpriseId, null, dto);
            return;
        }
        TabHaobanStaff staff = staffService.selectByUserIdAndEnterpriseId(wxUserId, wxEnterpriseId);
        if (staff == null) {
            log.info("staff不存在：{},{}", dto.getUnionid(), dto.getWxUserId());
            return;
        }
        String staffId = staff.getStaffId();
        TabHaobanClerkMainStoreRelated mainStoreRelated = clerkMainStoreRelatedService.getMainStoreByStaffId(staffId, wxEnterpriseId);
        if (mainStoreRelated == null) {
            log.info("【新增外部联系人】主门店为空:{}", staffId);
            return;
        }
        StaffClerkRelationDTO staffClerkRelationDTO = staffClerkRelationService.getOneBindByStoreId(staffId, mainStoreRelated.getStoreId());
        if (staffClerkRelationDTO == null) {
            log.info("【新增外币联系人】导购和clerk关联为空");
            return;
        }

        TabHaobanWxEnterpriseRelated wxEnterpriseRelated = wxEnterpriseRelatedService.getByEnterpriseId(staffClerkRelationDTO.getWxEnterpriseId(), staffClerkRelationDTO.getEnterpriseId());
        if (wxEnterpriseRelated == null) {
            log.info("没有存在企业关联：{},{}", staffClerkRelationDTO.getWxEnterpriseId(), staffClerkRelationDTO.getEnterpriseId());
            return;
        }
        //好友不开卡 发送欢迎语
        if (wxEnterpriseRelated.getMemberOpenCardFlag() == 1) {
            log.info("欢迎页面：");
            addFriendByWelcome(dto, staffClerkRelationDTO);
            return;
        } else {
            if (unionId == null) {
                log.info("unionid 不存在");
                return;
            }
            //新增导购和外部联系人关系
            String clerkCode = staffClerkRelationDTO.getClerkCode();
            ClerkDTO clerk = clerkService.getClerkByClerkCode(staffClerkRelationDTO.getEnterpriseId(), clerkCode);
            log.info("【新增外部联系人】clerkCode={},unionid:{}", clerkCode, unionId);
            if (clerk == null) {
                log.info("【新增外币联系人】导购为空:{},{}", clerkCode, unionId);
                return;
            }

            String qrcodeParam = clerk.getQrcodeParam();
            if (StringUtils.isBlank(qrcodeParam)) {
                powerService.saveClerkQrCode(clerk.getClerkId());
                clerk = clerkService.getClerkByClerkCode(staffClerkRelationDTO.getEnterpriseId(), clerkCode);
                qrcodeParam = clerk.getQrcodeParam();
            }
            if (StringUtils.isBlank(qrcodeParam)) {
                log.info("不能生产导购二维码：{}", JSONObject.toJSONString(clerk));
                return;
            }

            log.info("【新增外部联系人会员】enterpriseId={},unionId={},name={},avatar={},QrcodeParam={}", staffClerkRelationDTO.getEnterpriseId(), unionId, name, avatar, qrcodeParam);
            MemberDTO member = memberOpenCardBusinessService.getMemberByQywxChannelParam(staffClerkRelationDTO.getEnterpriseId(), unionId, "", name, avatar, qrcodeParam);
            if (member == null) {
                log.info("生产会员memnerid失败：{}", unionId);
                return;
            }
            List<TabHaobanExternalClerkRelated> externalClerkRelateds = externalClerkRelatedService.listByExTernalUseridAndWxUserIdAllStatus(dto.getExternalUserid(), dto.getWxUserId());
            if (CollectionUtils.isEmpty(externalClerkRelateds)) {
                log.info("新增TabHaobanExternalClerkRelated");
                TabHaobanExternalClerkRelated related = new TabHaobanExternalClerkRelated();
                related.setAddCreateTime(createTime);
                related.setClerkId(staffClerkRelationDTO.getClerkId());
                related.setEnterpriseId(staffClerkRelationDTO.getEnterpriseId());
                related.setExternalName(name);
                related.setExternalUserId(externalUserId);
                related.setStaffId(staffId);
                related.setHeadUrl(dto.getAvatar());
                related.setMemberUnionidRelatedId(dto.getMemberUnionidRelatedId());
                related.setStoreId(staffClerkRelationDTO.getStoreId());
                related.setUnionid(unionId);
                related.setWxEnterpriseId(wxEnterpriseId);
                related.setWxUserId(wxUserId);
                related.setMemberId(member.getMemberId());
                externalClerkRelatedService.insert(related);
            } else {
                log.info("更新TabHaobanExternalClerkRelated");
                TabHaobanExternalClerkRelated exsitDTO = externalClerkRelateds.get(0);
                exsitDTO.setMemberId(member.getMemberId());
                exsitDTO.setMemberUnionidRelatedId(dto.getMemberUnionidRelatedId());
                exsitDTO.setExternalUserId(externalUserId);
                exsitDTO.setUnionid(unionId);
                exsitDTO.setHeadUrl(dto.getAvatar());
                exsitDTO.setStoreId(staffClerkRelationDTO.getStoreId());
                exsitDTO.setEnterpriseId(staffClerkRelationDTO.getEnterpriseId());
                exsitDTO.setClerkId(staffClerkRelationDTO.getClerkId());
                exsitDTO.setStatusFlag(1);
                externalClerkRelatedService.update(exsitDTO);
            }
            sendWelcome(dto, staffClerkRelationDTO, false);
            //同步好友标签
            pushTagSync(member.getMemberId(), wxEnterpriseId, staffClerkRelationDTO.getEnterpriseId());
        }

    }

    private void sendWelcome(MemberUnionidRelatedDTO dto, StaffClerkRelationDTO staffClerkRelationDTO, boolean sendApp) {
        log.info("发送欢迎语：{}", JSONObject.toJSONString(staffClerkRelationDTO));
        String relationKey = SecureUtil.md5(staffClerkRelationDTO.getClerkId() + dto.getExternalUserid());


        TabWelcome tabWelcome = welcomeMapper.selectByWxEnterpriseId(staffClerkRelationDTO.getWxEnterpriseId());
        if (null == tabWelcome || tabWelcome.getOpenFlag() == 0) {
            log.info("不用发送欢迎语：{},{}", dto.getWxEnterpriseId(), JSONObject.toJSONString(tabWelcome));
            return;
        }

        String externalName = dto.getExternalName();
        String content = tabWelcome.getWelcomeContent().replaceAll("<微信昵称>", externalName);
        QywxWelcomeMsgDTO qywxWelcomeMsgDTO = new QywxWelcomeMsgDTO();
        qywxWelcomeMsgDTO.setText(tabWelcome == null ? "欢迎您！" : content);
        //发送小吃店哪个系
        if (sendApp) {
            QywxMiniprogramExternalBaseDTO messageBaseDTO = new QywxMiniprogramExternalBaseDTO();
            TabMiniprogramSetting miniprogramSetting = miniprogramSettingService.getMiniprogramSetting(staffClerkRelationDTO.getWxEnterpriseId(), staffClerkRelationDTO.getEnterpriseId());
            if (null == miniprogramSetting) {
                log.info("需要配置小程序配置：{}", staffClerkRelationDTO.getWxEnterpriseId(), staffClerkRelationDTO.getEnterpriseId());
                return;
            }
            messageBaseDTO.setAppid(miniprogramSetting.getAppId());
            messageBaseDTO.setPicMediaId(miniprogramSetting.getMediaId());
            messageBaseDTO.setTitle(miniprogramSetting.getTitle());
            messageBaseDTO.setPage(config.getMemberOpenPage() + relationKey);
            qywxWelcomeMsgDTO.setAttachments(new ArrayList<>());
            qywxWelcomeMsgDTO.getAttachments().add(messageBaseDTO);
        }
        qywxWelcomeMsgDTO.setWelcomeCode(dto.getWelcomeCode());
        if (dto.getSuiteid().equals(SELF_APP)) {
            SecretSettingDTO secretSetting = secretSettingService.getSecretSetting(dto.getWxEnterpriseId(), SecretTypeEnum.HAOBAN_HELP.getVal());
            qywxUserApiService.sendSelfWelcomeMsgByExternal(dto.getCorpid(), secretSetting.getSecretVal(), qywxWelcomeMsgDTO);
        } else {
            qywxUserApiService.sendWelcomeMsgByExternal(dto.getCorpid(), config.getWxSuiteid(), qywxWelcomeMsgDTO);
        }
    }

    /**
     * 欢迎语新增好友
     *
     * @param dto
     */
    private void addFriendByWelcome(MemberUnionidRelatedDTO dto, StaffClerkRelationDTO staffClerkRelationDTO) {
        String relationKey = SecureUtil.md5(staffClerkRelationDTO.getClerkId() + dto.getExternalUserid());
        //保存好友关系
        List<TabHaobanExternalClerkRelated> externalClerkRelateds = externalClerkRelatedService.listByExTernalUseridAndWxUserIdAllStatus(dto.getExternalUserid(), dto.getWxUserId());
        if (CollectionUtils.isEmpty(externalClerkRelateds)) {
            log.info("新增TabHaobanExternalClerkRelated");
            TabHaobanExternalClerkRelated related = new TabHaobanExternalClerkRelated();
            related.setAddCreateTime(dto.getAddCreateTime());
            related.setClerkId(staffClerkRelationDTO.getClerkId());
            related.setEnterpriseId(staffClerkRelationDTO.getEnterpriseId());
            related.setExternalName(dto.getExternalName());
            related.setExternalUserId(dto.getExternalUserid());
            related.setStaffId(staffClerkRelationDTO.getStaffId());
            related.setMemberUnionidRelatedId(dto.getMemberUnionidRelatedId());
            related.setStoreId(staffClerkRelationDTO.getStoreId());
            related.setRelationKey(relationKey);
            related.setStatusFlag(4);
            related.setPushTimes(1);
            related.setWxEnterpriseId(staffClerkRelationDTO.getWxEnterpriseId());
            related.setWxUserId(dto.getWxUserId());
            related.setHeadUrl(dto.getAvatar());
            externalClerkRelatedService.insert(related);
        } else {
            log.info("更新TabHaobanExternalClerkRelated");
            TabHaobanExternalClerkRelated exsitDTO = externalClerkRelateds.get(0);
            exsitDTO.setMemberUnionidRelatedId(dto.getMemberUnionidRelatedId());
            exsitDTO.setExternalUserId(dto.getExternalUserid());
            exsitDTO.setStoreId(staffClerkRelationDTO.getStoreId());
            exsitDTO.setEnterpriseId(staffClerkRelationDTO.getEnterpriseId());
            exsitDTO.setClerkId(staffClerkRelationDTO.getClerkId());
            exsitDTO.setRelationKey(relationKey);
            exsitDTO.setHeadUrl(dto.getAvatar());
            exsitDTO.setStatusFlag(4);
            externalClerkRelatedService.update(exsitDTO);
        }
        sendWelcome(dto, staffClerkRelationDTO, true);
    }

    @Deprecated
    private String insertMemberUnionIdRelated(MemberUnionidRelatedDTO dto) {
        if (dto == null) {
            return "";
        }
        String wxUserId = dto.getWxUserId();
        String wxEnterpriseId = dto.getWxEnterpriseId();
        String name = dto.getExternalName();
        String createTime = dto.getAddCreateTime();
        if (StringUtils.isAnyBlank(wxUserId, wxEnterpriseId, name, createTime)) {
            log.info("【新增外部联系人】wxUserId={},wxEnterpriseId={},name={},createTime={}", wxUserId, wxEnterpriseId, name, createTime);
            return "";
        }
        MemberUnionidRelatedDTO exsitDTO = memberUnionRelatedService.getByParams(wxUserId, wxEnterpriseId, name, createTime);
        String uuid = "";
        if (exsitDTO == null) {
            uuid = memberUnionRelatedService.addMemberUnionidRelated(dto);
        } else {
            //如果是自建更新uuid
            exsitDTO.setSelfExternalUserid(dto.getSelfExternalUserid());
            exsitDTO.setUnionid(dto.getUnionid());
            //更新对外联系人id
            exsitDTO.setExternalUserid(dto.getExternalUserid());
            memberUnionRelatedService.update(exsitDTO);
            uuid = exsitDTO.getMemberUnionidRelatedId();

            MemberUnionidRelatedDTO fullDTO = memberUnionRelatedService.getByParams(wxUserId, wxEnterpriseId, name, createTime);
            dto.setExternalUserid(fullDTO.getExternalUserid());
            dto.setUnionid(fullDTO.getUnionid());
        }
        return uuid;

    }

    @Deprecated
    private MemberUnionidRelatedDTO getMemberUnionidRelatedDTO(MemberUnionidRelatedDTO dto) {
        log.info("【新增外部联系人回调】dto={}", JSON.toJSONString(dto));
        String corpId = dto.getCorpid();
        TabHaobanWxEnterprise wxEnterprise = wxEnterpriseService.getEnterpriseBycorpId(corpId);
        if (wxEnterprise == null) {
            return null;
        }

        String wxEnterpriseId = wxEnterprise.getWxEnterpriseId();
        String userId = dto.getWxUserId();
        String suiteid = dto.getSuiteid();
        String unionIdJson = "";
        if (SELF_APP.equals(suiteid)) {
            SecretSettingDTO secretSetting = secretSettingService.getSecretSetting(wxEnterpriseId, SecretTypeEnum.CONTACT_CUSTOMER.getVal());
            if (null == secretSetting) {
                log.info("没有配置secret");
                return null;
            }
            unionIdJson = qywxUserApiService.getCorpSelfExternalUseridInfo(dto.getCorpid(), secretSetting.getSecretVal(), dto.getExternalUserid());
        } else {
            unionIdJson = qywxUserApiService.getExternalUseridInfo(dto.getCorpid(), dto.getSuiteid(), dto.getExternalUserid());
        }

        if (StringUtils.isBlank(unionIdJson)) {
            log.info("【新增外部联系人回调】unionIdJson=null");
            return null;
        }
        log.info("【新增外部联系人回调】unionIdJson={}", JSON.toJSONString(unionIdJson));

        ExternalUserPojo pojo = getExternalUserPojo(unionIdJson, userId, wxEnterpriseId);
        String name = pojo.getName();
        String createTime = pojo.getAddCreateTime();

        dto.setWxEnterpriseId(wxEnterpriseId);

        dto.setExternalName(name);
        dto.setAddCreateTime(createTime);
        dto.setAvatar(pojo.getAvatar());

        String externalUserId = null;
        String selfExternalUserId = null;
        String unionId = null;
        if (SELF_APP.equals(suiteid)) {
            unionId = pojo.getUnionId();
            selfExternalUserId = dto.getExternalUserid();
        } else {
            externalUserId = dto.getExternalUserid();
        }
        dto.setUnionid(unionId);
        dto.setSelfExternalUserid(selfExternalUserId);
        dto.setExternalUserid(externalUserId);
        return dto;
    }

    /**
     * 组装数据
     *
     * @param dto
     * @return
     */
    public MemberUnionidRelatedDTO getMemberUnionidRelatedDTONew(MemberUnionidRelatedDTO dto) {
        log.info("【新增外部联系人回调】dto={}", JSON.toJSONString(dto));
        String corpId = dto.getCorpid();
        TabHaobanWxEnterprise wxEnterprise = wxEnterpriseService.getEnterpriseBycorpId(corpId);
        if (wxEnterprise == null) {
            return null;
        }
        //校验friend
        CheckFriendSettingDTO friendSettingDTO = checkQywxSettingApiService.getFriendSetting();
        String wxEnterpriseId = wxEnterprise.getWxEnterpriseId();
        String userId = dto.getWxUserId();
        String suiteid = dto.getSuiteid();
        ExternalUserDTO externalUserDTO;
        if (SELF_APP.equals(suiteid)) {
            externalUserDTO = this.getCorpSelfExternalUseridInfo(wxEnterpriseId, userId, dto.getExternalUserid());
        } else {
            externalUserDTO = this.getExternalUseridInfo(wxEnterpriseId, userId, dto.getExternalUserid());
        }
        checkQywxSettingApiService.saveFriendCallback(wxEnterpriseId, externalUserDTO, dto);
        if (externalUserDTO == null) {
            log.info("【新增外部联系人回调】unionIdJson=null");
            return null;
        }

        dto.setWxEnterpriseId(wxEnterpriseId);
        dto.setExternalName(EmojiFilterUtil.removeAllEmoji(externalUserDTO.getName()));
        dto.setAddCreateTime(externalUserDTO.getAddCreateTime());
        dto.setAvatar(externalUserDTO.getAvatar());
        if (SELF_APP.equals(suiteid)) {
            dto.setUnionid(externalUserDTO.getUnionId());
            dto.setSelfExternalUserid(externalUserDTO.getExternalUserId());
            dto.setExternalUserid(null);
            dto.setAvatar(externalUserDTO.getAvatar());
        } else {
            dto.setExternalUserid(externalUserDTO.getExternalUserId());
        }
        String key = "external" + dto.getWxEnterpriseId() + "_" + dto.getWxUserId() + "_" + dto.getExternalName() + "_" + dto.getAddCreateTime();
        String lockKey = key + "-lock";
        RedisUtil.lock(lockKey, 10L);
        MemberUnionidRelatedDTO midRelatedDto = RedisUtil.getCache(key, MemberUnionidRelatedDTO.class);

        if (midRelatedDto != null) {
            dto.setUnionid(dto.getUnionid() == null ? midRelatedDto.getUnionid() : dto.getUnionid());
            dto.setExternalUserid(dto.getExternalUserid() == null ? midRelatedDto.getExternalUserid() : dto.getExternalUserid());
            dto.setSelfExternalUserid(dto.getSelfExternalUserid() == null ? midRelatedDto.getSelfExternalUserid() : dto.getSelfExternalUserid());
            dto.setMemberUnionidRelatedId(midRelatedDto.getMemberUnionidRelatedId());
            dto.setAvatar(dto.getAvatar() == null ? midRelatedDto.getAvatar() : dto.getAvatar());
            List<MemberUnionidRelatedDTO> relatedDTOS = memberUnionRelatedService.listBySelfExternalUserId(dto.getWxUserId(), dto.getWxEnterpriseId(), dto.getSelfExternalUserid());
            //老的关联需要删除
            if (CollectionUtils.isNotEmpty(relatedDTOS)) {
                relatedDTOS.stream().filter(mid -> (!mid.getMemberUnionidRelatedId().equals(midRelatedDto.getMemberUnionidRelatedId())))
                        .forEach(mid -> {
                            mid.setStatusFlag(0);
                            memberUnionRelatedService.update(mid);
                        });

            }
            memberUnionRelatedService.update(dto);
            RedisUtil.unlock(lockKey);
            RedisUtil.delCache(key);
            return dto;
        } else {
            String memberUnionidRelatedId = memberUnionRelatedService.addMemberUnionidRelated(dto);
            dto.setMemberUnionidRelatedId(memberUnionidRelatedId);
            RedisUtil.setCache(key, dto, 60L);
            RedisUtil.unlock(lockKey);
            return null;
        }
    }


    private ExternalUserPojo getExternalUserPojo(String unionIdJson, String userId1, String wxEnterpriseId) {
        ExternalUserPojo pojo = new ExternalUserPojo();
        String unionId = "";
        String follow_user = "";
        String createTime = "";
        String userId = "";
        String avatar = "";
        String relaName = "";
        String externalUserId = "";
        if (StringUtils.isNotBlank(unionIdJson)) {
            JSONObject jo = JSON.parseObject(unionIdJson);
            String external_contact = jo.getString("external_contact");
            if (StringUtils.isNotBlank(external_contact)) {
                JSONObject jt = JSON.parseObject(external_contact);
                unionId = jt.getString("unionid");
                relaName = EmojiFilterUtil.filterEmojiLast(jt.getString("name"), true);
                if (StringUtils.isBlank(relaName)) {
                    relaName = "--";
                }
                avatar = jt.getString("avatar");
                externalUserId = jt.getString("external_userid");
            }

            follow_user = jo.getString("follow_user");
            if (StringUtils.isNotBlank(follow_user)) {
                JSONArray j = JSON.parseArray(follow_user);
                for (Object object : j) {
                    String followJson = JSON.toJSONString(object);
                    JSONObject follow = JSON.parseObject(followJson);
                    userId = follow.getString("userid");
                    if (userId.equals(userId1)) {
                        createTime = follow.getString("createtime");
                    }
                }
            }
        }
        pojo.setAddCreateTime(createTime);
        pojo.setAvatar(avatar);
        pojo.setName(relaName);
        pojo.setUnionId(unionId);
        pojo.setExternalUserId(externalUserId);
        pojo.setWxEnterpriseId(wxEnterpriseId);
        return pojo;
    }

    @Override
    public String add(String wxEnterpriseId, String selfExternalUserId, String userId, String storeId) {
        WxEnterpriseDTO wxEnterprise = wxEnterpriseService.selectById(wxEnterpriseId);
        if (wxEnterprise == null) {
            return "";
        }

        TabHaobanStaff staff = staffService.selectByUserIdAndEnterpriseId(userId, wxEnterpriseId);
        if (staff == null) {
            return "";
        }

        SecretSettingDTO secretSetting = secretSettingService.getSecretSetting(wxEnterpriseId, SecretTypeEnum.CONTACT_CUSTOMER.getVal());
        if (null == secretSetting) {
            log.info("没有配置secret");
            return "";
        }
        String unionIdJson = qywxUserApiService.getCorpSelfExternalUseridInfo(wxEnterprise.getCorpid(), secretSetting.getSecretVal(), selfExternalUserId);

        ExternalUserPojo pojo = getExternalUserPojo(unionIdJson, userId, wxEnterpriseId);
        String unionId = pojo.getUnionId();
        String name = pojo.getName();
        String createTime = pojo.getAddCreateTime();


        MemberUnionidRelatedDTO dto = new MemberUnionidRelatedDTO();
        String externalUserId = getExternalUserId(wxEnterprise, userId, createTime, name);

        dto.setExternalUserid(externalUserId);
        dto.setWxEnterpriseId(wxEnterpriseId);
        dto.setUnionid(unionId);

        dto.setExternalName(name);
        dto.setAddCreateTime(createTime);
        dto.setWxUserId(userId);
        dto.setAvatar(pojo.getAvatar());
        if (StringUtils.isBlank(unionId)) {
            return "";
        }

        dto.setSuiteid(secretSetting.getSecretVal());

        MemberUnionidRelatedDTO exsitDTO = memberUnionRelatedService.getByParams(userId, wxEnterpriseId, name, createTime);
        String uuid = "";
        if (exsitDTO == null) {
            dto.setUnionid(unionId);
            //更新对外联系人id
            dto.setSelfExternalUserid(selfExternalUserId);
            uuid = memberUnionRelatedService.addMemberUnionidRelated(dto);
        } else {
            exsitDTO.setExternalUserid(externalUserId);
            exsitDTO.setUnionid(unionId);
            //更新对外联系人id
            exsitDTO.setSelfExternalUserid(selfExternalUserId);
            memberUnionRelatedService.update(exsitDTO);
            uuid = exsitDTO.getMemberUnionidRelatedId();
            //return "";
        }

        //新增门店和导购的关联关系
        insertExternalClerkRelated(dto);
        return uuid;
    }


    private String getExternalUserId(WxEnterpriseDTO wxEnterprise, String userId1, String createTime, String name) {
        log.info("新增外部联系人】corpid={},suiteId={},userId1={}", wxEnterprise.getCorpid(), config.getWxSuiteid(), userId1);
        String wxRes = qywxUserApiService.listExternalUserid(wxEnterprise.getCorpid(), config.getWxSuiteid(), userId1);
        String externalUserId = "";
        log.info("【新增外部联系人】wxRes={}", wxRes);
        if (StringUtils.isNotBlank(wxRes)) {
            JSONArray jsonArr = JSON.parseArray(wxRes);
            String wxName = "";
            for (Object externalUserid : jsonArr) {
                String uJ = qywxUserApiService.getExternalUseridInfo(wxEnterprise.getCorpid(), config.getWxSuiteid(), externalUserid.toString());
                log.info("【新增外部联系人】uJ={}", uJ);
                if (StringUtils.isNotBlank(uJ)) {
                    JSONObject jo = JSON.parseObject(uJ);
                    String external_contact = jo.getString("external_contact");
                    String uj_follow_user = jo.getString("follow_user");
                    JSONObject jt = null;
                    if (StringUtils.isNotBlank(external_contact)) {
                        jt = JSON.parseObject(external_contact);
                        wxName = EmojiFilterUtil.filterEmojiLast(jt.getString("name"), true);
                        if (StringUtils.isBlank(wxName)) {
                            wxName = "--";
                        }
                    }
                    if (StringUtils.isNotBlank(uj_follow_user)) {
                        JSONArray j = JSON.parseArray(uj_follow_user);
                        String uj_userId = "";
                        for (Object object : j) {
                            String followJson = JSON.toJSONString(object);
                            JSONObject follow = JSON.parseObject(followJson);
                            uj_userId = follow.getString("userid");
                            log.info("【新增外部联系人】createTime={},name={},followCreateTime={},wxName={}", createTime, name, follow.getString("createtime"), wxName);
                            if (uj_userId.equals(userId1) && createTime.equals(follow.getString("createtime")) && name.equals(wxName)) {
                                if (jt != null) {
                                    externalUserId = jt.getString("external_userid");
                                    break;
                                }
                            }
                        }
                    }
                }
                if (StringUtils.isNotBlank(externalUserId)) {
                    break;
                }
            }
        }
        return externalUserId;
    }

    @Override
    public void delMemberUnionidRelated(MemberUnionidRelatedDTO dto) {
        DealQywxExternalUserPojo dealQywxExternalUserPojo = new DealQywxExternalUserPojo();
        dealQywxExternalUserPojo.setType(DealQywxExternalUserPojo.DealType.del.getType());
        dealQywxExternalUserPojo.setData(dto);

        GicMQClient instance = GICMQClientUtil.getClientInstance();
        try {
            instance.sendMessage("dealQywxExternalUserMq", JSONObject.toJSONString(dealQywxExternalUserPojo));
        } catch (Exception e) {
            log.info("异步处理异常：{}", e);
        }
    }

    @Override
    public void editMemberUnionidRelated(MemberUnionidRelatedDTO dto) {
        DealQywxExternalUserPojo dealQywxExternalUserPojo = new DealQywxExternalUserPojo();
        dealQywxExternalUserPojo.setType(DealQywxExternalUserPojo.DealType.edit.getType());
        dealQywxExternalUserPojo.setData(dto);

        GicMQClient instance = GICMQClientUtil.getClientInstance();
        try {
            instance.sendMessage("dealQywxExternalUserMq", JSONObject.toJSONString(dealQywxExternalUserPojo));
        } catch (Exception e) {
            log.info("异步处理异常：{}", e);
        }
    }

    /**
     * 删除好友
     *
     * @param dto
     */
    private void delMemberUnionidRelatedProcess(MemberUnionidRelatedDTO dto) {
        externalClerkRelatedService.delByUserIdAndExternalUserId(dto);
        memberUnionRelatedService.delMemberUnionidRelated(dto);

    }

    /**
     * 删除好友
     *
     * @param dto
     */
    private void editMemberUnionidRelatedProcess(MemberUnionidRelatedDTO dto) {
        log.info("修改标签/会员信息回调：{}", JSONObject.toJSONString(dto));
        TabHaobanWxEnterprise wxEnterprise = wxEnterpriseService.getEnterpriseBycorpId(dto.getCorpid());
        if (null == wxEnterprise) {
            return;
        }
        if (dto.getSuiteid().equals(SELF_APP)) {
            log.info("self不执行");
            return;
        }
        qywxTagApiService.syncQywxTagToGicByExternalUserId(wxEnterprise.getWxEnterpriseId(), dto.getExternalUserid(), dto.getWxUserId());
    }

    @Override
    public ExternalClerkRelatedDTO getByMemberId(String staffId, String memberId) {
        TabHaobanStaff staff = staffService.selectById(staffId);
        if (staff == null) {
            return null;
        }
        log.info("【查询会员】wxUserId={},unionid={}", staff.getWxUserId(), memberId);
        return externalClerkRelatedService.getByMemberId(staff.getWxUserId(), memberId);
    }

    @Override
    public List<MemberUnionidRelatedDTO> getByWxUserIdAndWxEnterpriseId(String wxUserId, String wxEnterpriseId) {
        List<MemberUnionidRelatedDTO> list = memberUnionRelatedService.getByWxUserIdAndWxEnterpriseId(wxUserId, wxEnterpriseId);
        return list;
    }

    @Override
    public List<MemberUnionidRelatedDTO> listByEnterpriseIdAndDate(String enterpriseId, Date date) {
        List<MemberUnionidRelated> list = memberUnionidRelatedMapper.listByEnterpriseIdAndDate(enterpriseId, date);
        return EntityUtil.changeEntityListByJSON(MemberUnionidRelatedDTO.class, list);
    }

    @Override
    public void freshWxFrend(String wxEnterpriseId, String wxUserId, String storeId) {
        log.info("【刷下好友】wxUserId={}", wxUserId);
        WxEnterpriseDTO enterprise = wxEnterpriseService.selectById(wxEnterpriseId);

        String wxRes = qywxUserApiService.listExternalUserid(enterprise.getCorpid(), config.getWxSuiteid(), wxUserId);
        List<MemberUnionidRelatedDTO> list = this.getByWxUserIdAndWxEnterpriseId(wxUserId, wxEnterpriseId);
        List<String> externalUserIdList = list.stream().map(external -> external.getExternalUserid())
                .collect(Collectors.toList());
        JSONArray externalArr = JSON.parseArray(wxRes);
        for (String externalUserId : externalUserIdList) {
            if (!externalArr.contains(externalUserId)) {
                //删除成员和外部联系人关系
                MemberUnionidRelatedDTO dto = new MemberUnionidRelatedDTO();
                dto.setExternalUserid(externalUserId);
                dto.setWxUserId(wxUserId);
                memberUnionRelatedService.delMemberUnionidRelated(dto);
                //删除导购和外部联系人关系
                externalClerkRelatedService.delByUserIdAndExternalUserId(dto);
            }
        }


        SecretSettingDTO secretSetting = secretSettingService.getSecretSetting(wxEnterpriseId, SecretTypeEnum.CONTACT_CUSTOMER.getVal());
        if (null == secretSetting || secretSetting.getCheckFlag() == 0) {
            log.info("没有配置客户联系secret:{}", wxEnterpriseId);
            return;
        }
        String res = qywxUserApiService.listSelfExternalUserid(enterprise.getCorpid(), secretSetting.getSecretVal(), wxUserId);
        log.info("【刷下好友】res={}", res);
        if (StringUtils.isBlank(res)) {
            return;
        }
        JSONArray jsonArr = JSON.parseArray(res);
        if (jsonArr.size() == 0) {
            return;
        }


        for (Object object : jsonArr) {
            this.add(wxEnterpriseId, object.toString(), wxUserId, storeId);
        }

    }

    @Override
    public void mqFreshWxFrend(String res) {
        JSONObject json = JSON.parseObject(res);
        String wxEnterpriseId = json.getString("wxEnterpriseId");
        String wxUserId = json.getString("wxUserId");
        String storeId = json.getString("storeId");
        log.info("【刷下微信好友】wxEnterpriseId={}.wxUserId={},storeId={}", wxEnterpriseId, wxUserId, storeId);
        if (StringUtils.isAnyBlank(wxEnterpriseId, wxUserId, storeId)) {
            return;
        }
        freshWxFrend(wxEnterpriseId, wxUserId, storeId);
    }

    @Override
    public void cleanByCid(String cid) {
        if (StringUtils.isNotBlank(cid)) {
            TabHaobanWxEnterprise wxEnterprise = wxEnterpriseService.getEnterpriseBycorpId(cid);
            if (null != wxEnterprise) {
                memberUnionRelatedService.clean(wxEnterprise.getWxEnterpriseId());
            }
        } else {
            memberUnionRelatedService.clean(null);
        }
    }

    @Override
    public Page<MemberUnionidRelatedDTO> pageMemberUnionByParams(List<String> userIdList, List<String> sendMemberIds,
                                                                 String enterpriseId, BasePageInfo pageInfo) {
        PageHelper.startPage(pageInfo.getPageNum(), pageInfo.getPageSize());
        return PageUtil.changePageHelperToCurrentPage(memberUnionRelatedService.pageMemberUnionByParams(userIdList, sendMemberIds, enterpriseId), MemberUnionidRelatedDTO.class);
    }

//	@Override
//	public String sendMessage(String wxEnterpriseId,String userId,List<String> extendUserList,String materialId){
//		WxEnterpriseDTO enterprise = wxEnterpriseService.selectById(wxEnterpriseId);
//		MaterialDTO material = materialApiService.selectMaterialById(materialId);
//		if(material == null){
//			return "";
//		}
//		JSONResponse jp = null;
//		if(material.getMaterialType() == 2 || material.getMaterialType() == 4 || material.getMaterialType() == 5){
//			Date wxLastTime = material.getWxLastUploadTime();
//			String maerialId = material.getMediaId();
//			if(DateUtil.addDay(wxLastTime, 3).getTime() < System.currentTimeMillis()){
//				maerialId = materialApiService.reUpdalodMetail(materialId);
//			}
//			QywxImageExternalMessageDTO dto = new QywxImageExternalMessageDTO();
//			dto.setMediaId(maerialId);
//			dto.setChatType("single");
//			dto.setExternalUserid(extendUserList);
//			dto.setSenderUserId(userId);
//			log.info("【发送消息】dto = {}",JSON.toJSONString(dto));
//			jp = qywxSuiteApiService.sendExternalMessage(enterprise.getCorpid(), config.getWxSuiteid(), dto);
//		}else if(material.getMaterialType() == 1){
//			QywxTextExternalMessageDTO dto = new QywxTextExternalMessageDTO();
//			dto.setChatType("single");
//			dto.setExternalUserid(extendUserList);
//			dto.setSenderUserId(userId);
//			dto.setText(material.getMaterialContent());
//			log.info("【发送消息】dto = {}",JSON.toJSONString(dto));
//			jp = qywxSuiteApiService.sendExternalMessage(enterprise.getCorpid(), config.getWxSuiteid(), dto);
//		}else if(material.getMaterialType() == 3){
//			QywxIinkExternalMessageDTO dto = new QywxIinkExternalMessageDTO();
//			dto.setChatType("single");
//			dto.setExternalUserid(extendUserList);
//			dto.setSenderUserId(userId);
//			dto.setDesc(material.getMaterialDesc());
//			dto.setPicurl(material.getWxImgUrl());
//			dto.setTitle(material.getMaterialTitle());
//			dto.setUrl(material.getLink());
//			log.info("【发送消息】dto = {}",JSON.toJSONString(dto));
//			jp = qywxSuiteApiService.sendExternalMessage(enterprise.getCorpid(), config.getWxSuiteid(), dto);
//		}
//		log.info("【发送消息】jp = {}",JSON.toJSONString(jp));
//		Map<String,Object> returnMap = jp.getReturnMap();
//		return returnMap.get("msgid") == null?"":returnMap.get("msgid").toString();
//	}

    /**
     * 老的单个素材群发的api
     *
     * @param wxEnterpriseId : 微信企业id
     * @param userId         : 用户id
     * @param extendUserList : 发送的用户id
     * @param materialId     : 素材id
     * @return : 返回群发执行结果
     */
    @Override
    public String sendMessage(String wxEnterpriseId, String userId, List<String> extendUserList, String materialId) {
        JSONResponse jp = this.sendMessage(wxEnterpriseId, userId, extendUserList, Collections.singletonList(materialId));
        //返回执行结果, msgId
        log.info("【发送消息】jp = {}", JSON.toJSONString(jp));
        Map<String, Object> returnMap = jp.getReturnMap();
        return returnMap.get("msgid") == null ? "" : returnMap.get("msgid").toString();
    }

    /**
     * 创建企业群发, 支出素材批量发送
     *
     * @param wxEnterpriseId : 微信企业id
     * @param userId         : 用户id
     * @param extendUserList : 发送的用户id
     * @param materialIdList : 素材id列表
     * @return : 返回群发执行结果
     */
    @Override
    public JSONResponse sendMessage(String wxEnterpriseId, String userId, List<String> extendUserList, List<String> materialIdList) {
        //群发请求参数
        QywxExternalMessageDTO qywxExternalMessageDTO = new QywxExternalMessageDTO();
        //素材列表
        List<QywxMessageMaterialDTO> messageMaterialList = new ArrayList<>();
        materialIdList.forEach(materialId -> {
            MaterialDTO material = materialApiService.getHasChangeMadieMaterialById(materialId);
            if (material == null) {
                return;
            }
            if (material.getMaterialType() == 1) {
                qywxExternalMessageDTO.setContent(material.getMaterialContent());
            } else {
                messageMaterialList.add(this.getMessageMaterial(material));
            }
        });
        //素材列表不存在, 并且不存在文本内容, 不执行
        if (messageMaterialList.isEmpty() && StringUtils.isBlank(qywxExternalMessageDTO.getContent())) {
            JSONResponse jp = new JSONResponse();
            jp.setErrorCode(-1);
            jp.setErrorMessage("群发素材不存在, 群发创建失败");
            return jp;
        }
        //请求参数赋值
        qywxExternalMessageDTO.setChatType("single");
        qywxExternalMessageDTO.setExternalUserid(extendUserList);
        qywxExternalMessageDTO.setSenderUserId(userId);
        qywxExternalMessageDTO.setAttachments(messageMaterialList);
        //调接口执行创建群发
        WxEnterpriseDTO enterprise = wxEnterpriseService.selectById(wxEnterpriseId);
        return qywxSuiteApiService.sendExternalMessage(enterprise.getCorpid(), config.getWxSuiteid(), qywxExternalMessageDTO);
    }

    /**
     * 素材发送对象构造
     *
     * @param material : 素材对象
     * @return : 返回素材发送对象
     */
    private QywxMessageMaterialDTO getMessageMaterial(MaterialDTO material) {
        //素材类型
        Integer materialType = material.getMaterialType();
        //主键id
        String materialId = material.getMaterialId();
        //企微对应的id
        String maerialId = material.getMediaId();
        //判断素材企微id是否需要刷新
        List<Integer> materialTypeList = Arrays.asList(2, 4, 6);
        if (materialTypeList.contains(materialType)) {
            Date wxLastTime = material.getWxLastUploadTime();
            if (DateUtil.addDay(wxLastTime, 3).getTime() < System.currentTimeMillis()) {
                maerialId = materialApiService.reUpdalodMetail(materialId);
            }
        }
        //素材对象
        QywxMessageMaterialDTO dto = new QywxMessageMaterialDTO();
        if (materialType == 2) {
            QywxImageMaterialDTO imageMaterialDTO = new QywxImageMaterialDTO();
            imageMaterialDTO.setMediaId(maerialId);
            dto.setMsgType("image");
            dto.setImage(imageMaterialDTO);
        } else if (materialType == 3) {
            QywxLinkMaterialDTO linkMaterialDTO = new QywxLinkMaterialDTO();
            linkMaterialDTO.setTitle(material.getMaterialTitle());
            linkMaterialDTO.setPicUrl(material.getWxImgUrl());
            linkMaterialDTO.setDesc(material.getMaterialDesc());
            linkMaterialDTO.setUrl(material.getLink());
            dto.setMsgType("link");
            dto.setLink(linkMaterialDTO);
        } else if (materialType == 4) {
            QywxVideoMaterialDTO videoMaterialDTO = new QywxVideoMaterialDTO();
            videoMaterialDTO.setMediaId(maerialId);
            dto.setMsgType("video");
            dto.setVideo(videoMaterialDTO);
        } else if (materialType == 6) {
            QywxMiniprogramMaterialDTO miniprogramMaterialDTO = new QywxMiniprogramMaterialDTO();
            miniprogramMaterialDTO.setTitle(material.getMaterialTitle());
            miniprogramMaterialDTO.setPicMediaId(maerialId);
            miniprogramMaterialDTO.setAppid(material.getAppId());
            miniprogramMaterialDTO.setPage(material.getLink());
            dto.setMsgType("miniprogram");
            dto.setMiniprogram(miniprogramMaterialDTO);
        }
        return dto;
    }

    /**
     * 获取群发成员发送任务列表
     *
     * @param wxEnterpriseId : 微信企业id
     * @param wxMessageId    : 消息id
     * @param cursor         : 分页游标
     * @return : 返回请求结果
     */
    @Override
    public JSONResponse taskExternalMessage(String wxEnterpriseId, String wxMessageId, String cursor) {
        WxEnterpriseDTO enterprise = wxEnterpriseService.selectById(wxEnterpriseId);
        if (enterprise == null) {
            return null;
        }
        return qywxSuiteApiService.taskExternalMessage(enterprise.getCorpid(), config.getWxSuiteid(), wxMessageId, cursor);
    }

    /**
     * 获取企业群发成员执行结果
     *
     * @param wxEnterpriseId : 微信企业id
     * @param wxMessageId    : 消息id
     * @param cursor         : 分页游标
     * @param userId         : 用户id
     * @return : 返回请求结果
     */
    @Override
    public JSONResponse resultExternalMessage(String wxEnterpriseId, String wxMessageId, String cursor, String userId) {
        WxEnterpriseDTO enterprise = wxEnterpriseService.selectById(wxEnterpriseId);
        if (enterprise == null) {
            return null;
        }
        return qywxSuiteApiService.resultExternalMessage(enterprise.getCorpid(), config.getWxSuiteid(), wxMessageId, cursor, userId);
    }

    @Override
    public JSONResponse getMessageStatus(String wxEnterpriseId, String wxMessageId) {
        WxEnterpriseDTO enterprise = wxEnterpriseService.selectById(wxEnterpriseId);
        if (enterprise == null) {
            return null;
        }
        JSONResponse jp = qywxSuiteApiService.resultExternalMessage(enterprise.getCorpid(), config.getWxSuiteid(), wxMessageId);
        return jp;
    }

    @Override
    public List<MemberUnionidRelatedDTO> getByWxUserIdListAndWxEnterpriseId(List<String> userIdList,
                                                                            String wxEnterpriseId) {
        return EntityUtil.changeEntityListByJSON(MemberUnionidRelatedDTO.class, memberUnionidRelatedMapper.getByWxUserIdListAndWxEnterpriseId(userIdList, wxEnterpriseId));
    }

    @Override
    public void cleanNoExsitFriend(String wxEnterpriseId, String wxUserId, String wxRes) {
        log.info("【清除不存在的好友】wxEnterpriseId={},wxUserId={}", wxEnterpriseId, wxUserId);
        WxEnterpriseDTO enterprise = wxEnterpriseService.selectById(wxEnterpriseId);

        //String wxRes = qywxUserApiService.listExternalUserid(enterprise.getCorpid(), config.getWxSuiteid(), wxUserId);
        List<MemberUnionidRelatedDTO> list = this.getByWxUserIdAndWxEnterpriseId(wxUserId, wxEnterpriseId);
        List<String> externalUserIdList = list.stream().map(external -> external.getExternalUserid())
                .collect(Collectors.toList());
        if (StringUtils.isBlank(wxRes)) {
            log.info("【清除不存在的好友不存在】wxEnterpriseId={},wxUserId={}", wxEnterpriseId, wxUserId);
            return;
        }
        JSONArray externalArr = JSON.parseArray(wxRes);
        for (String externalUserId : externalUserIdList) {
            if (!externalArr.contains(externalUserId)) {
                //删除成员和外部联系人关系
                MemberUnionidRelatedDTO dto = new MemberUnionidRelatedDTO();
                dto.setExternalUserid(externalUserId);
                dto.setWxUserId(wxUserId);
                memberUnionRelatedService.delMemberUnionidRelated(dto);
                //删除导购和外部联系人关系
                externalClerkRelatedService.delByUserIdAndExternalUserId(dto);
            }
        }

    }

    @Override
    public List<String> listSelfExterialList(String wxEnterpriseId, String wxUserId) {
        try {
            log.info("【查询自建应用好友】wxEnterpriseId={},wxUserId={}", wxEnterpriseId, wxUserId);
            WxEnterpriseDTO enterprise = wxEnterpriseService.selectById(wxEnterpriseId);
            List<String> list = new ArrayList<>();
            SecretSettingDTO secretSetting = secretSettingService.getSecretSetting(wxEnterpriseId, SecretTypeEnum.CONTACT_CUSTOMER.getVal());
            if (null == secretSetting || secretSetting.getCheckFlag() == 0) {
                log.info("没有配置客户联系secret:{}", wxEnterpriseId);
                return list;
            }
            String res = qywxUserApiService.listSelfExternalUserid(enterprise.getCorpid(), secretSetting.getSecretVal(), wxUserId);
            log.info("【查询自建应用】res={}", res);
            if (res != null && res.equals("1")) {
                log.info("代表需要重试");
                return null;
            }
            if (StringUtils.isBlank(res)) {
                return list;
            }
            JSONArray jsonArr = JSON.parseArray(res);
            if (jsonArr.size() == 0) {
                return list;
            }
            for (Object object : jsonArr) {
                list.add(object.toString());
            }
            return list;
        } catch (Exception e) {
            log.info("错误={}", e);
        }
        return null;
    }

    @Override
    public List<String> listExterialList(String wxEnterpriseId, String wxUserId) {
        log.info("【获取第三方应用好友】wxEnterpriseId={},wxUserId={}", wxEnterpriseId, wxUserId);
        WxEnterpriseDTO enterprise = wxEnterpriseService.selectById(wxEnterpriseId);
//		String wxRes = qywxUserApiService.listExternalUserid(enterprise.getCorpid(), "wwb3ef71aa8c6d9c06", wxUserId);
        String wxRes = qywxUserApiService.listExternalUserid(enterprise.getCorpid(), config.getWxSuiteid(), wxUserId);
        List<String> list = new ArrayList<>();
        log.info("【查询第三方应用】res={}", wxRes);
        if (wxRes != null && wxRes.equals("1")) {
            log.info("代表需要重试");
            return null;
        }
        if (StringUtils.isBlank(wxRes)) {
            return list;
        }
        JSONArray jsonArr = JSON.parseArray(wxRes);
        if (jsonArr.size() == 0) {
            return list;
        }
        for (Object object : jsonArr) {
            list.add(object.toString());
        }
        return list;
    }

    @Override
    public ExternalUserDTO getCorpSelfExternalUseridInfo(String wxEnterpriseId, String wxUserId, String externalUserId) {
        WxEnterpriseDTO wxEnterprise = wxEnterpriseService.selectById(wxEnterpriseId);
        if (wxEnterprise == null) {
            log.info("企业不存在");
            return null;
        }
        SecretSettingDTO secretSetting = secretSettingService.getSecretSetting(wxEnterpriseId, SecretTypeEnum.HAOBAN_HELP.getVal());
        if (null == secretSetting) {
            log.info("没有配置secret");
            return null;
        }
        String unionIdJson = qywxUserApiService.getCorpSelfExternalUseridInfo(wxEnterprise.getCorpid(), secretSetting.getSecretVal(), externalUserId);
        if (StringUtils.isBlank(unionIdJson)) {
            log.info("好友不存在");
            return null;
        } else if (unionIdJson.equals("1")) {
            log.info("接口调用被限制");
            throw new WxApiLimitException("getCorpSelfExternalUseridInfo接口调用被限制");
        }
        ExternalUserPojo pojo = getExternalUserPojo(unionIdJson, wxUserId, wxEnterpriseId);
        return EntityUtil.changeEntityByJSON(ExternalUserDTO.class, pojo);
    }

    @Override
    public ExternalUserDTO getExternalUseridInfo(String wxEnterpriseId, String wxUserId, String externalUserId) {
        WxEnterpriseDTO wxEnterprise = wxEnterpriseService.selectById(wxEnterpriseId);
        if (wxEnterprise == null) {
            log.info("企业不存在");
            return null;
        }
//		String uJ = qywxUserApiService.getExternalUseridInfo(wxEnterprise.getCorpid(), "wwb3ef71aa8c6d9c06", externalUserId);
        String uJ = qywxUserApiService.getExternalUseridInfo(wxEnterprise.getCorpid(), config.getWxSuiteid(), externalUserId);
        if (StringUtils.isBlank(uJ)) {
            log.info("好友不存在");
            return null;
        } else if (uJ.equals("1")) {
            log.info("限制次数");
            throw new WxApiLimitException("getExternalUseridInfo接口次数限制");
        }
        String name = "";
        String createTime = "";
        String avatar = "";
        Integer friendType = 1;
        if (StringUtils.isNotBlank(uJ)) {
            JSONObject jo = JSON.parseObject(uJ);
            String external_contact = jo.getString("external_contact");
            String uj_follow_user = jo.getString("follow_user");
            JSONObject jt = null;
            if (StringUtils.isNotBlank(external_contact)) {
                jt = JSON.parseObject(external_contact);
                name = EmojiFilterUtil.filterEmojiLast(jt.getString("name"), true);
                if (StringUtils.isBlank(name)) {
                    name = "--";
                }
                friendType = jt.getInteger("type");
                avatar = jt.getString("avatar");
            }
            if (StringUtils.isNotBlank(uj_follow_user)) {
                JSONArray j = JSON.parseArray(uj_follow_user);
                String uj_userId = "";
                for (Object object : j) {
                    String followJson = JSON.toJSONString(object);
                    JSONObject follow = JSON.parseObject(followJson);
                    uj_userId = follow.getString("userid");
                    if (uj_userId.equals(wxUserId)) {
                        if (jt != null) {
                            externalUserId = jt.getString("external_userid");
                            createTime = follow.getString("createtime");
                            break;
                        }
                    }
                }
            }
        }
        ExternalUserPojo pojo = new ExternalUserPojo();
        pojo.setExternalUserId(externalUserId);
        pojo.setName(name);
        pojo.setAddCreateTime(createTime);
        pojo.setWxEnterpriseId(wxEnterpriseId);
        pojo.setAvatar(avatar);
        pojo.setFriendType(friendType);
        return EntityUtil.changeEntityByJSON(ExternalUserDTO.class, pojo);
    }

    @Override
    public String addExternal(ExternalUserDTO dto) {
        String wxUserId = dto.getWxUserId();
        String wxEnterpriseId = dto.getWxEnterpriseId();
        String name = StringUtils.isBlank(dto.getName()) ? "--" : dto.getName();
        String createTime = dto.getAddCreateTime();
        String unionId = dto.getUnionId();
        String externalUserId = dto.getExternalUserId();
        String memberId = dto.getMemberId();
        String storeId = dto.getStoreId();
        String enterpriseId = dto.getEnterpriseId();
        String staffId = dto.getStaffId();
        String avatar = dto.getAvatar();
        String clerkId = dto.getClerkId();
        if (StringUtils.isAnyBlank(wxUserId, wxEnterpriseId, name, createTime, unionId, externalUserId, memberId, storeId, enterpriseId, staffId, clerkId)) {
            log.info("【新增外部联系人】wxUserId={},wxEnterpriseId={},name={},createTime={},unionId ={},externalUserId ={},memberId ={},storeId ={},enterpriseId ={},staffId={},clerkId={}"
                    + "", wxUserId, wxEnterpriseId, name, createTime, unionId, externalUserId, memberId, storeId, enterpriseId, staffId, clerkId);
            return "参数不对";
        }
        MemberUnionidRelatedDTO exsitDTO = memberUnionRelatedService.getByUnionId(wxEnterpriseId, wxUserId, unionId);
        String uuid = "";
        if (exsitDTO == null) {
            exsitDTO = new MemberUnionidRelatedDTO();
            exsitDTO.setAvatar(avatar);
            exsitDTO.setExternalUserid(externalUserId);
            exsitDTO.setAddCreateTime(createTime);
            exsitDTO.setEnterpriseId(enterpriseId);
            exsitDTO.setExternalName(name);
            exsitDTO.setExternalUserid(externalUserId);
            exsitDTO.setWxEnterpriseId(wxEnterpriseId);
            exsitDTO.setWxUserId(wxUserId);
            exsitDTO.setUnionid(unionId);
            uuid = memberUnionRelatedService.addMemberUnionidRelated(exsitDTO);
        } else {
            uuid = exsitDTO.getMemberUnionidRelatedId();
            exsitDTO.setAvatar(avatar);
            exsitDTO.setExternalUserid(externalUserId);
            exsitDTO.setUnionid(unionId);
            exsitDTO.setAddCreateTime(createTime);
            exsitDTO.setExternalName(name);

            memberUnionRelatedService.update(exsitDTO);
        }

        List<TabHaobanExternalClerkRelated> clerkRelateds = externalClerkRelatedService.listByExTernalUseridAndWxUserIdAllStatus(externalUserId, wxUserId);
        if (CollectionUtils.isEmpty(clerkRelateds)) {
            TabHaobanExternalClerkRelated related = new TabHaobanExternalClerkRelated();
            related.setAddCreateTime(createTime);
            related.setClerkId(clerkId);
            related.setEnterpriseId(enterpriseId);
            related.setExternalName(name);
            related.setExternalUserId(externalUserId);
            related.setStaffId(staffId);
            related.setMemberUnionidRelatedId(uuid);
            related.setStoreId(storeId);
            related.setUnionid(unionId);
            related.setWxEnterpriseId(wxEnterpriseId);
            related.setWxUserId(wxUserId);
            related.setMemberId(memberId);
            related.setHeadUrl(dto.getAvatar());
            related.setStatusFlag(1);
            externalClerkRelatedService.insert(related);

        } else {
            TabHaobanExternalClerkRelated external = clerkRelateds.get(0);
            external.setMemberId(memberId);
            external.setMemberUnionidRelatedId(uuid);
            external.setExternalUserId(externalUserId);
            external.setExternalName(name);
            external.setUnionid(unionId);
            external.setStoreId(storeId);
            external.setEnterpriseId(enterpriseId);
            external.setClerkId(clerkId);
            external.setStaffId(staffId);
            external.setMemberId(memberId);
            external.setHeadUrl(dto.getAvatar());
            external.setStatusFlag(1);
            externalClerkRelatedService.update(external);
        }
        //同步标签
        pushTagSync(memberId, wxEnterpriseId, enterpriseId);

        return "";
    }

    private void pushTagSync(String memberId, String wxEnterpriseId, String enterpriseId) {
        QywxTagSyncInfoPojo pojo = new QywxTagSyncInfoPojo();
        pojo.setDataId(memberId);
        pojo.setTaskId("-1");
        pojo.setTaskType(QywxSyncTaskTypeEnum.MEMBER_SYNC.getType());
        //单个会员同步
        pojo.setSyncType(GicQywxSyncTypeEnum.IMPORT_MEMBER.getType());
        pojo.setWxEnterpriseId(wxEnterpriseId);
        pojo.setEnterpriseId(enterpriseId);
        GicMQClient clientInstance = GICMQClientUtil.getClientInstance();
        try {
            clientInstance.sendMessage("qywxTagSyncDeal", JSONObject.toJSONString(pojo));
        } catch (Exception e) {
            e.printStackTrace();
            log.info("异常：{}", e);
        }
    }

    @Override
    public String addFriendExternal(ExternalUserDTO dto) {
        String wxUserId = dto.getWxUserId();
        String wxEnterpriseId = dto.getWxEnterpriseId();
        String name = StringUtils.isBlank(dto.getName()) ? "--" : dto.getName();
        String createTime = dto.getAddCreateTime();
        String externalUserId = dto.getExternalUserId();
        String storeId = dto.getStoreId();
        String enterpriseId = dto.getEnterpriseId();
        String staffId = dto.getStaffId();
        String avatar = dto.getAvatar();
        String clerkId = dto.getClerkId();
        String selfExternalUserId = dto.getSelfExternalUserId();
        if (StringUtils.isAnyBlank(wxUserId, selfExternalUserId, wxEnterpriseId, name, createTime, externalUserId, storeId, enterpriseId, staffId, clerkId)) {
            log.info("【新增外部联系人】wxUserId={},selfExternalUserId={},wxEnterpriseId={},name={},createTime={},unionId ={},externalUserId ={},memberId ={},storeId ={},enterpriseId ={},staffId={},clerkId={}"
                    + "", wxUserId, selfExternalUserId, wxEnterpriseId, name, createTime, externalUserId, storeId, enterpriseId, staffId, clerkId);
            return "参数不对";
        }
        String relationKey = SecureUtil.md5(dto.getClerkId() + dto.getExternalUserId());

        MemberUnionidRelatedDTO exsitDTO = memberUnionRelatedService.getBySelfExternalUserId(wxUserId, wxEnterpriseId, dto.getSelfExternalUserId());
        String uuid = "";
        if (exsitDTO == null) {
            exsitDTO = new MemberUnionidRelatedDTO();
            exsitDTO.setAvatar(avatar);
            exsitDTO.setSelfExternalUserid(dto.getSelfExternalUserId());
            exsitDTO.setAddCreateTime(createTime);
            exsitDTO.setEnterpriseId(enterpriseId);
            exsitDTO.setExternalName(name);
            exsitDTO.setExternalUserid(externalUserId);
            exsitDTO.setWxEnterpriseId(wxEnterpriseId);
            exsitDTO.setWxUserId(wxUserId);
            uuid = memberUnionRelatedService.addMemberUnionidRelated(exsitDTO);
        } else {
            uuid = exsitDTO.getMemberUnionidRelatedId();
            exsitDTO.setAvatar(avatar);
            exsitDTO.setExternalUserid(externalUserId);
            exsitDTO.setAddCreateTime(createTime);
            exsitDTO.setExternalName(name);

            memberUnionRelatedService.update(exsitDTO);
        }

        List<TabHaobanExternalClerkRelated> clerkRelateds = externalClerkRelatedService.listByExTernalUseridAndWxUserIdAllStatus(externalUserId, wxUserId);
        if (CollectionUtils.isEmpty(clerkRelateds)) {
            TabHaobanExternalClerkRelated related = new TabHaobanExternalClerkRelated();
            related.setAddCreateTime(createTime);
            related.setClerkId(clerkId);
            related.setEnterpriseId(enterpriseId);
            related.setExternalName(name);
            related.setExternalUserId(externalUserId);
            related.setStaffId(staffId);
            related.setMemberUnionidRelatedId(uuid);
            related.setStoreId(storeId);
            related.setWxEnterpriseId(wxEnterpriseId);
            related.setWxUserId(wxUserId);
            related.setStatusFlag(3);
            related.setHeadUrl(dto.getAvatar());
            related.setRelationKey(relationKey);
            externalClerkRelatedService.insert(related);

        } else {
            TabHaobanExternalClerkRelated external = clerkRelateds.get(0);
            external.setMemberUnionidRelatedId(uuid);
            external.setExternalUserId(externalUserId);
            external.setExternalName(name);
            external.setStoreId(storeId);
            external.setEnterpriseId(enterpriseId);
            external.setClerkId(clerkId);
            external.setStaffId(staffId);
            external.setHeadUrl(dto.getAvatar());
            external.setRelationKey(relationKey);
            external.setStatusFlag(external.getStatusFlag() == 1 ? 1 : external.getStatusFlag());
            externalClerkRelatedService.update(external);
        }
        return "";
    }

    @Override
    public void cleanNoExsitFriendNew(String wxEnterpriseId, String wxUserId, List<String> externalUserIds) {
        log.info("【清除不存在的好友】wxEnterpriseId={},wxUserId={}", wxEnterpriseId, wxUserId);
        //查询所有的外部联系人
        List<MemberUnionidRelatedDTO> list = memberUnionRelatedService.getByWxUserIdAndWxEnterpriseId(wxUserId, wxEnterpriseId);
        if (CollectionUtils.isEmpty(list)) {
            log.info("改导购下没有外部联系人，无需清理外部联系人：{},{}", wxUserId, wxEnterpriseId);
            return;
        }
        Set<String> externalUserIdList = list.stream().map(external -> external.getExternalUserid())
                .collect(Collectors.toSet());

        Sets.SetView<String> delExternalUserIds = Sets.difference(new HashSet<>(externalUserIds), externalUserIdList);
        if (CollectionUtils.isEmpty(delExternalUserIds)) {
            log.info("没有需要删除逇外部联系人:{},{}", wxUserId, wxEnterpriseId);
            return;
        }
        //删除成员与union的关联关系
        memberUnionRelatedService.delMemberUnionidRelatedBatch(wxEnterpriseId, wxUserId, new ArrayList<>(delExternalUserIds));
        //删除导购和外部联系人关系
        externalClerkRelatedService.delByUserIdAndExternalUserIdBatch(wxEnterpriseId, wxUserId, new ArrayList<>(delExternalUserIds));

    }

    @Override
    public ServiceResponse<List<FriendStoreInfoDTO>> listFriendClerkByMemberUnionid(String enterpriseId, String unionId) {
        ServiceResponse<List<FriendStoreInfoDTO>> resp = new ServiceResponse<>();
        if (StringUtils.isAnyBlank(enterpriseId, unionId)) {
            resp.setMessage("参数有误");
            resp.setCode(2);
            return resp;
        }
        List<TabHaobanExternalClerkRelated> relateds = externalClerkRelatedService.listExternalByUnionId(enterpriseId, unionId);
        if (CollectionUtils.isEmpty(relateds)) {
            return resp;
        }
        //导购信息
        Set<String> clerkIds = relateds.stream().map(dto -> dto.getClerkId()).collect(Collectors.toSet());
        log.info("获取clerkIds：{}", JSONObject.toJSONString(clerkIds));
        List<ClerkDTO> clerkDTOS = clerkService.getClerkByIds(clerkIds);
        if (CollectionUtils.isEmpty(clerkDTOS)) {
            log.info("没有有效的导购");
            return resp;
        }
        Map<String, ClerkDTO> clerkMap = clerkDTOS.stream().collect(Collectors.toMap(ClerkDTO::getClerkId, dto -> dto));

        //门店信息
        List<String> storeIds = relateds.stream().map(dto -> dto.getStoreId()).collect(Collectors.toList());
        log.info("门店storeIds：{}", JSONObject.toJSONString(storeIds));
        List<StoreDTO> storeDTOS = storeService.queryStore(storeIds);
        if (CollectionUtils.isEmpty(storeDTOS)) {
            log.info("没有关联的门店");
            return resp;
        }
        Map<String, StoreDTO> storeMap = storeDTOS.stream().collect(Collectors.toMap(StoreDTO::getStoreId, dto -> dto));

        //组装
        log.info("组装返回的好友导购信息:{}", unionId);
        List<FriendStoreInfoDTO> ret = relateds.stream().map(related -> {
            ClerkDTO clerkDTO = clerkMap.get(related.getClerkId());
            StoreDTO storeDTO = storeMap.get(related.getStoreId());

            FriendStoreInfoDTO friendStoreInfoDTO = new FriendStoreInfoDTO();
            friendStoreInfoDTO.setAddFriendTime(related.getAddCreateTime());
            friendStoreInfoDTO.setClerkId(related.getClerkId());
            friendStoreInfoDTO.setStoreId(related.getStoreId());
            friendStoreInfoDTO.setWxUserId(related.getWxUserId());
            friendStoreInfoDTO.setStoreCode(storeDTO != null ? storeDTO.getStoreCode() : null);
            friendStoreInfoDTO.setStoreName(storeDTO != null ? storeDTO.getStoreName() : null);
            friendStoreInfoDTO.setClerkCode(clerkDTO != null ? clerkDTO.getClerkCode() : null);
            friendStoreInfoDTO.setClerkName(clerkDTO != null ? clerkDTO.getClerkName() : null);
            friendStoreInfoDTO.setClerkPhoneNumber(clerkDTO != null ? clerkDTO.getPhoneNumber() : null);
            return friendStoreInfoDTO;
        }).collect(Collectors.toList());
        resp.setResult(ret);
        return resp;
    }

    @Override
    public MemberUnionidRelatedDTO getExternalUseridInfoBySelfExternalUserId(String wxEnterpriseId, String wxUserId, String selfExternalUserId) {
        return memberUnionRelatedService.getBySelfExternalUserId(wxUserId, wxEnterpriseId, selfExternalUserId);
    }
}
