package com.gic.haoban.manage.web.controller;

import cn.hutool.core.collection.CollectionUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.gic.clerk.api.dto.ClerkDTO;
import com.gic.clerk.api.service.ClerkService;
import com.gic.dict.api.dto.DictDTO;
import com.gic.dict.api.service.ManagerDictService;
import com.gic.enterprise.api.dto.EnterpriseDTO;
import com.gic.enterprise.api.dto.StoreDTO;
import com.gic.enterprise.api.service.EnterpriseService;
import com.gic.haoban.app.customer.dto.StaffOpenRelatedDTO;
import com.gic.haoban.app.customer.service.api.service.StaffMemberRelationApiService;
import com.gic.haoban.common.utils.EntityUtil;
import com.gic.haoban.common.utils.HaobanResponse;
import com.gic.haoban.manage.api.dto.*;
import com.gic.haoban.manage.api.enums.SecretTypeEnum;
import com.gic.haoban.manage.api.service.*;
import com.gic.haoban.manage.web.config.Config;
import com.gic.haoban.manage.web.errCode.HaoBanErrCode;
import com.gic.haoban.manage.web.qo.GetUserByMemberCodeQo;
import com.gic.haoban.manage.web.qo.MemberLoginQo;
import com.gic.haoban.manage.web.vo.AppStaffVo;
import com.gic.haoban.manage.web.vo.InfoVo;
import com.gic.haoban.manage.web.vo.MemberSendMessageVo;
import com.gic.haoban.manage.web.vo.StoreMemberVO;
import com.gic.member.api.service.MemberOpenCardBusinessService;
import com.gic.wechat.api.dto.qywx.UserDTO;
import com.gic.wechat.api.service.qywx.QywxCorpApiService;
import com.gic.wechat.api.service.qywx.QywxUserApiService;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.stream.Collectors;

@RestController
public class InfoController extends WebBaseController{
//	public static final  String siteId = "ww2c34dc56739bb105";

	@Autowired
	private QywxCorpApiService qywxCorpApiService;
	@Autowired
	private StaffApiService staffApiService;
	@Autowired
	private WxEnterpriseApiService wxEnterpriseApiService;

    @Autowired
    private WxEnterpriseRelatedApiService wxEnterpriseRelatedApiService;

    @Autowired
    private QywxUserApiService qywxUserApiService;

    @Autowired
    private DepartmentApiService departmentApiService;

    @Autowired
    private com.gic.enterprise.api.service.StoreService storeService;

    @Autowired
    private MemberUnionidRelatedApiService memberUnionidRelatedApiService;
    @Autowired
    private ClerkService clerkService;
    
	@Autowired
	private ClerkMainStoreRelatedApiService clerkMainStoreRelatedApiService;
	@Autowired
	private StaffDepartmentRelatedApiService staffDepartmentRelatedApiService;

	@Autowired
	private ManagerDictService managerDictService;

	@Autowired
	private StaffMemberRelationApiService staffMemberRelationApiService;

	@Autowired
	private StaffClerkRelationApiService staffClerkRelationApiService;

    @Autowired
    private ExternalClerkRelatedApiService externalClerkRelatedApiService;

    @Autowired
    private MemberOpenCardBusinessService memberOpenCardBusinessService;

    @Autowired
    private EnterpriseService enterpriseService;

    private static Logger logger= LoggerFactory.getLogger(InfoController.class);

	@Autowired
	private Config config;

	@RequestMapping("get-info-by-code")
    public HaobanResponse getInfoByCode(String code) {
        String userDTOJson = qywxCorpApiService.getCodeSession(config.getWxSuiteid(),code);
        logger.info("userDTOJson=============>{}",userDTOJson);
        UserDTO user = JSON.parseObject(userDTOJson, UserDTO.class);
        if(user == null) {

            return resultResponse(HaoBanErrCode.ERR_6);
        }
        String userId = user.getUserid();
        String corpId = user.getCorpid();
        WxEnterpriseDTO enterprise = wxEnterpriseApiService.getEnterpriseBycorpId(corpId);
        StaffDTO loginStaff = null;
        if(enterprise != null){
            loginStaff = staffApiService.selectByUserIdAndEnterpriseId(userId,enterprise.getWxEnterpriseId());
        }
        if(loginStaff == null){
            if(enterprise != null){
                staffApiService.wxGetAdd(userId,enterprise.getWxEnterpriseId());
                loginStaff = staffApiService.selectByUserIdAndEnterpriseId(userId,enterprise.getWxEnterpriseId());
            }
        }
        if(loginStaff == null){
            return resultResponse(HaoBanErrCode.ERR_600001);
        }
        if (StringUtils.isNotBlank(loginStaff.getPhoneNumber())) {
            DictDTO loginUserId = managerDictService.getSMSDict("app_login_phone_num", loginStaff.getPhoneNumber());
            logger.info("伪登录：{}，userId:{}",loginStaff.getPhoneNumber(), JSONObject.toJSONString(loginUserId));
            if (null != loginUserId) {
                String val = loginUserId.getDictValue();
                List<StaffDTO> staffDTOS=new ArrayList<>();
                List<StaffDTO> phoneDtos = staffApiService.listByPhoneNumber(val);
                List<StaffDTO> userDtos = staffApiService.listByWxUserId(val);
                if (CollectionUtils.isNotEmpty(phoneDtos)) {
                    staffDTOS.addAll(phoneDtos);
                }
                if (CollectionUtils.isNotEmpty(userDtos)) {
                    staffDTOS.addAll(userDtos);
                }
                if (CollectionUtils.isNotEmpty(staffDTOS)) {
                    loginStaff = staffDTOS.get(0);
                    if (staffDTOS.size() > 1) {
                        String dictName = loginUserId.getDictName();
                        String[] split = dictName.split("-");
                        if (split.length > 1) {
                            String weiCorpId = split[1];
                            WxEnterpriseDTO weiWxEnterpriseDTO = wxEnterpriseApiService.getEnterpriseBycorpId(weiCorpId);
                            if (null != weiWxEnterpriseDTO) {
                                loginStaff = staffDTOS.stream().filter(staffDTO -> {
                                    if (weiWxEnterpriseDTO.getWxEnterpriseId().equals(staffDTO.getWxEnterpriseId())) {
                                        return true;
                                    } else {
                                        return false;
                                    }
                                }).findFirst().orElse(staffDTOS.get(0));
                            }
                        }
                    }
                }
//                StaffDTO staffDTO = staffApiService.selectByNationcodeAndPhoneNumber(enterprise.getWxEnterpriseId(), "86", midPhone);
//                if (null !=staffDTO) {
//                    loginStaff=staffDTO;
//                }
            }

        }
        //激活状态
        if(loginStaff.getActiveFlag()==0) {
            staffApiService.activeStaff(loginStaff.getStaffId());
        }

        String wxEnterpriseId = loginStaff.getWxEnterpriseId();
        WxEnterpriseDTO wxEnterpriseDTO = wxEnterpriseApiService.getOne(wxEnterpriseId);
        String accesstoken = qywxCorpApiService.getCorpAccessToken(wxEnterpriseDTO.getCorpid(), config.getWxSuiteid());
        InfoVo infoVo = new InfoVo();
        infoVo.setAccessToken(accesstoken);
        infoVo.setStaffId(loginStaff.getStaffId());
        infoVo.setWxEnterpriseId(wxEnterpriseId);
        infoVo.setStaffName(loginStaff.getStaffName());
        infoVo.setPhoneNumber(loginStaff.getPhoneNumber());
        infoVo.setNationcode(loginStaff.getNationCode());
        infoVo.setWxUserId(loginStaff.getWxUserId());
        return resultResponse(HaoBanErrCode.ERR_1,infoVo);

    }

    @RequestMapping("get-gyt-info-by-code")
    public HaobanResponse getGytCode(String code) {
        String userDTOJson = qywxUserApiService.getUserByCode("ww9ede832a84b7ae5f", "lHHKe1X683yWYAdwWATdzRTdVWo8uTnPH3nj5Gkt4og", code);
        logger.info(userDTOJson);
        return resultResponse(HaoBanErrCode.ERR_1,userDTOJson);
    }

    @RequestMapping("get-user-by-member-code")
    public HaobanResponse getInfoByMemberCode(GetUserByMemberCodeQo qo) {
//        if (qo.getMemberId().equals("ff80808172cbd0410172cc894e6503c9")) {
//            return resultResponse(HaoBanErrCode.ERR_500003, "1111");
//        }
        WxEnterpriseDTO enterpriseDetailDTO = null;
        if (StringUtils.isNotBlank(qo.getCorpId())) {
            enterpriseDetailDTO = wxEnterpriseApiService.getEnterpriseBycorpId(qo.getCorpId());
            if (null == enterpriseDetailDTO) {
                logger.info("改企业没有关系好办1:{}", qo.getGicEnterpriseId());
                return resultResponse(HaoBanErrCode.ERR_500001);
            }
        } else {
            List<WxEnterpriseDTO> wxEnterpriseDTOS = wxEnterpriseRelatedApiService.listWxEnterpriseByEid(qo.getGicEnterpriseId());
            if (CollectionUtils.isEmpty(wxEnterpriseDTOS)) {
                logger.info("改企业没有关系好办:{}", qo.getGicEnterpriseId());
                return resultResponse(HaoBanErrCode.ERR_500001);
            }
            enterpriseDetailDTO = wxEnterpriseDTOS.get(0);
        }

        WxEnterpriseDTO enterpriseDTO = wxEnterpriseApiService.getOne(enterpriseDetailDTO.getWxEnterpriseId());
        if (enterpriseDTO == null) {
            logger.info("改企业不存在:{}", qo.getGicEnterpriseId());
            return resultResponse(HaoBanErrCode.ERR_400002);
        }

        MemberLoginQo user = new MemberLoginQo();
        if (StringUtils.isBlank(qo.getUserId())) {
            user = getUserByCode(enterpriseDTO, qo.getCode(), qo.getGicEnterpriseId());
            if (user != null && (!user.getCorpId().equals(enterpriseDTO.getCorpid()))) {
                return resultResponse(HaoBanErrCode.ERR_500003, user.getCorpId());
            }
            if (user == null) {
                return resultResponse(HaoBanErrCode.ERR_6);
            }

        } else {
            user.setUserId(qo.getUserId());
        }
        StaffDTO staffDTO = staffApiService.selectByUserIdAndEnterpriseId(user.getUserId(), enterpriseDTO.getWxEnterpriseId());
        if (staffDTO == null) {
            logger.info("成员不存在");
            return resultResponse(HaoBanErrCode.ERR_6);
        }
        //保存关联关系
        StaffOpenRelatedDTO relatedDTO = new StaffOpenRelatedDTO();
        relatedDTO.setMemberId(qo.getMemberId());
        relatedDTO.setOpenId(qo.getOpenid());
        relatedDTO.setStaffId(staffDTO.getStaffId());
        relatedDTO.setWxEnterpriseId(enterpriseDTO.getWxEnterpriseId());
        relatedDTO.setGicEnterpriseId(qo.getGicEnterpriseId());
        staffMemberRelationApiService.bindMemberAndStaff(relatedDTO);

        //补充字段赋值
        user.setStaffId(staffDTO.getStaffId());
        user.setWxEnterpriseId(staffDTO.getWxEnterpriseId());
        user.setStaffName(staffDTO.getStaffName());
        user.setPhoneNumber(staffDTO.getPhoneNumber());
        user.setNationCode(staffDTO.getNationCode());
        user.setWxUserId(staffDTO.getWxUserId());


        List<StaffClerkInfoDTO> result = staffClerkRelationApiService.listBindDetailByStaffId(staffDTO.getStaffId());

        List<StoreMemberVO> retList = new ArrayList<>();
        if (CollectionUtils.isNotEmpty(result)) {
            result.stream().filter(staffClerkInfoDTO -> {
                if (staffClerkInfoDTO.getEnterpriseId().equals(qo.getGicEnterpriseId())) {
                    return true;
                }else{
                    return false;
                }
            }).forEach(dto -> {
                StoreMemberVO VO = new StoreMemberVO();
                StoreDTO store = storeService.getStore(dto.getStoreId());
                ClerkDTO clerkDTO = clerkService.getClerkByClerkId(dto.getClerkId());
                if (null != store&&clerkDTO!=null) {
                    VO.setUserId(staffDTO.getWxUserId());
                    VO.setStoreId(dto.getStoreId());//为空，则无该值
                    VO.setStoreName(dto.getStoreName());
                    VO.setWxEnterpriseId(dto.getWxEnterpriseId());
                    VO.setEnterpriseId(store.getEnterpriseId());
                    VO.setStoreImg(store.getImageUrl());//先置空
                    VO.setBindFlag(1);
                    VO.setClerkCode(clerkDTO.getClerkCode());
                    VO.setClerkType(clerkDTO.getClerkType());
                    VO.setStaffId(staffDTO.getStaffId());
                    VO.setClerkId(clerkDTO.getClerkId());

                    retList.add(VO);
                }

            });
            user.setStoreList(retList);
        }
        return resultResponse(HaoBanErrCode.ERR_1, user);

    }

    private MemberLoginQo getUserByCode(WxEnterpriseDTO enterpriseDTO, String code, String enterpriseId) {
        SecretSettingDTO secretSetting = wxEnterpriseApiService.getSecretSetting(enterpriseDTO.getWxEnterpriseId(), SecretTypeEnum.MEMBER_WAPP.getVal(), enterpriseId);
        if (null == secretSetting || StringUtils.isBlank(secretSetting.getSecretVal())) {
            logger.info("MEMBER_WAPPsecret配置没有配置");
            return null;
        }
        String userDTOJson = qywxUserApiService.getUserByCode(enterpriseDTO.getCorpid(), secretSetting.getSecretVal(), code);
        logger.info("会员微信登录信息=============>{}", userDTOJson);
        MemberLoginQo user = JSON.parseObject(userDTOJson, MemberLoginQo.class);
        if (user == null) {
            return null;
        }
        return user;
    }

    @RequestMapping("save-user-login-log")
	public HaobanResponse saveUserLoginLog(UserLoginLogDTO userLoginLogDTO) {
		staffApiService.insertUserLoginLog(userLoginLogDTO);
		return resultResponse(HaoBanErrCode.ERR_1);
		
	}
	
	@RequestMapping("get-member-store")
    public HaobanResponse getMemberStore(String externalUserid, String wxUserId, String storeId) {
        if (StringUtils.isAnyBlank(externalUserid,wxUserId)) {
            return resultResponse(HaoBanErrCode.ERR_2);
        }
        List<MemberStoreDTO> result = memberUnionidRelatedApiService.listByExTernalUseridAndWxUserId(externalUserid, wxUserId, storeId);
        return resultResponse(HaoBanErrCode.ERR_1,result);
	}
	
	@RequestMapping("get-staff-info")
	public HaobanResponse getStaffInfo(String phoneNumber) {
        if (StringUtils.isBlank(phoneNumber)) {
            return resultResponse(HaoBanErrCode.ERR_2);
        }
        List<StaffDTO> list = staffApiService.listByPhoneNumber(phoneNumber);
        if(CollectionUtil.isNotEmpty(list)){
        	List<AppStaffVo> staffs = EntityUtil.changeEntityListByJSON(AppStaffVo.class, list);
        	Set<String> wxEnterpriseIds = list.stream().map(s->s.getWxEnterpriseId()).collect(Collectors.toSet());
        	List<YwWxEnterpriseDTO> enterprises = wxEnterpriseApiService.listByIds(wxEnterpriseIds);
        	Map<String,YwWxEnterpriseDTO> map = com.gic.commons.util.CollectionUtil.toMap(enterprises, "wxEnterpriseId");
        	for(AppStaffVo vo:staffs){
        		String wxEnterpriseId = vo.getWxEnterpriseId();
        		String corpName = map.get(wxEnterpriseId) == null?"":map.get(wxEnterpriseId).getCorpName();
        		vo.setWxEnterpriseName(corpName);
        	}
    		return resultResponse(HaoBanErrCode.ERR_1,staffs);
        }
		return resultResponse(HaoBanErrCode.ERR_1,new ArrayList<>());
		
	}

    /**
     * 获取绑定信息
     *
     * @param externalUserid
     * @param wxUserId
     * @param wxEnterpriseId
     * @return
     */
    @RequestMapping("get-send-message-info")
    public HaobanResponse getMessageMember(String externalUserid, String wxUserId, String wxEnterpriseId, String gicEnterpriseId) {
        if (StringUtils.isAnyBlank(externalUserid, wxUserId, wxEnterpriseId)) {
            return resultResponse(HaoBanErrCode.ERR_2);
        }
        WxEnterpriseRelationDetailDTO enterpriseBindInfo = wxEnterpriseRelatedApiService.getEnterpriseBindInfo(wxEnterpriseId, gicEnterpriseId);
        if (null == enterpriseBindInfo) {
            logger.info("企业不存在没有绑定");
            return resultResponse(HaoBanErrCode.ERR_400002);
        }
        if (enterpriseBindInfo.getMemberOpenCardFlag() != 1) {
            logger.info("该企业在同一个开平，无需手动关联:wxEid:{}, eid:{}", wxEnterpriseId, gicEnterpriseId);
            return resultResponse(HaoBanErrCode.ERR_11125);
        }
        MemberUnionidRelatedDTO memberUnionidRelatedDTO = memberUnionidRelatedApiService.getExternalUseridInfoBySelfExternalUserId(wxEnterpriseId, wxUserId, externalUserid);
        if (null == memberUnionidRelatedDTO) {
            logger.info("请刷新好友");
            return resultResponse(HaoBanErrCode.ERR_11123);
        }
        List<ExternalClerkRelatedDTO> clerkRelatedDTOS = externalClerkRelatedApiService.listExternalClerkByWxUserIdAncExternalUserId(wxEnterpriseId, wxUserId, gicEnterpriseId, memberUnionidRelatedDTO.getExternalUserid());
        if (CollectionUtils.isEmpty(clerkRelatedDTOS)) {
            logger.info("该企业没有对应需要发送的信息村子啊");
            return resultResponse(HaoBanErrCode.ERR_11123);
        }

        MiniprogramSettingDTO settingDTO = wxEnterpriseApiService.getMiniprogramSettingByEid(wxEnterpriseId, gicEnterpriseId);
        if (null == settingDTO) {
            logger.info("该企业没有对应需要发送的信息村子啊");
            return resultResponse(HaoBanErrCode.ERR_11124);
        }
        EnterpriseDTO enterpriseDTO = enterpriseService.getEnterpriseById(gicEnterpriseId);
        ExternalClerkRelatedDTO clerkRelatedDTO = clerkRelatedDTOS.get(0);
        MemberSendMessageVo memberSendMessageVo = new MemberSendMessageVo();
        memberSendMessageVo.setRelationKey(clerkRelatedDTO.getRelationKey());
        memberSendMessageVo.setImageUrl(settingDTO.getImageUrl());
        memberSendMessageVo.setMediaId(settingDTO.getMediaId());
        memberSendMessageVo.setSelfExteralUserId(externalUserid);
        memberSendMessageVo.setTitle(settingDTO.getTitle());
        memberSendMessageVo.setWxaHandUrl(enterpriseDTO.getMallMiniprogramLogoUrl());
        memberSendMessageVo.setBindFlag(clerkRelatedDTO.getStatusFlag() == 1 ? 1 : 0);
        memberSendMessageVo.setWxaName(settingDTO.getMiniprogramName());


        return resultResponse(HaoBanErrCode.ERR_1, memberSendMessageVo);
    }

    /**
     * 绑定好友
     * @param memberId
     * @param enterpriseId
     * @param unionid
     * @param relationKey
     * @return
     */
    @RequestMapping("member-bind-friend")
    public HaobanResponse memberBindFriend(String memberId, String enterpriseId, String unionid, String relationKey) {
        if (StringUtils.isAnyBlank(memberId, enterpriseId, relationKey)) {
            return resultResponse(HaoBanErrCode.ERR_2);
        }
        memberOpenCardBusinessService.memberClerkProcessByQywxFriend(enterpriseId, memberId, unionid, relationKey);
        return resultResponse(HaoBanErrCode.ERR_1);
    }

}
